#pragma once
#include <fstream>
using namespace std;
namespace HostServer{
	class SyncHelper
	{
	public:
		//************************************
		// Description: char[5]long long
		// Method:      parseTime
		// Returns:     long long 
		// Parameter:   char * time msgЯʱ Ϊ5char
		//************************************
		static long long parseTime(const char *time);

		//************************************
		// Description: վߺƴӳһ
		// Method:      parseId
		// Returns:     unsigned long long ƴӺı
		// Parameter:   unsigned int id վ
		// Parameter:   unsigned char antNum ߺ
		//************************************
		static unsigned long long parseId(unsigned int id, unsigned char antNum);

        //************************************
        // Description: ļз
        // Method:      parseFromFstream
        // Returns:     unsigned long long
        // Parameter:   ifstream & f
        // Parameter:   int size
        //************************************
        static unsigned long long parseFromFstream(ifstream &f, int size);

        //************************************
        // Description: ļзʱ
        // Method:      parseTimeFromFstream
        // Returns:     unsigned long long
        // Parameter:   ifstream & f
        //************************************
        static unsigned long long parseTimeFromFstream(ifstream &f);
	};
}