
// YAServer.cpp : ӦóΪ
//

#include "stdafx.h"
#include "YAServer.h"
#include "YAServerDlg.h"
#include "def.h"
#include "INIFILE.h"
#include "Functions/Functions.h"
#include "minidupm.h"
#include "tlhelp32.h"

#include "ProcessRemodule.h"
#include "log_process_module.h"

#include "./system_basic_info/SystemAnalysis.h"
#include "./debug_server/debug_server_socket.h"

#pragma warning(disable: 4005)

extern int debug_server_init(void);

// CYAServerApp

BEGIN_MESSAGE_MAP(CYAServerApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CYAServerApp 

CYAServerApp::CYAServerApp()
{
	// ֧
	m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;
	// TODO: ڴ˴ӹ룬
	// Ҫĳʼ InitInstance 
}


// Ψһһ CYAServerApp 

CYAServerApp theApp;

//HINSTANCE g_hResOld; // ɵԴ
//HINSTANCE g_hDll; // DLLԴ
// CYAServerApp ʼ

BOOL CYAServerApp::InitInstance()
{
	// һ Windows XP ϵӦó嵥ָҪ
	// ʹ ComCtl32.dll 汾 6 ߰汾ÿӻʽ
	//Ҫ InitCommonControlsEx()򣬽޷ڡ

	//ɼ
	CreateMutex(NULL, FALSE, _T("MyMux"));
	if(GetLastError() == ERROR_ALREADY_EXISTS){
		HWND hWnd = ::FindWindow(NULL, _T("ͨݲɼϵͳ"));
		::PostMessage(hWnd, WM_QUIT, 0, 0);
		//captionΪ㴰ڵľcaption
		//::ShowWindow(hWnd,SW_SHOW);
		//::SetForegroundWindow(hWnd); // 
		//return FALSE;
	}

	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// ΪҪӦóʹõ
	// ؼࡣ
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	SetUnhandledExceptionFilter(ExceptionFilter);

	CWinApp::InitInstance();
	
	AfxEnableControlContainer();

	//  shell ԷԻ
	// κ shell ͼؼ shell бͼؼ
	CShellManager *pShellManager = new CShellManager;

	// ׼ʼ
	// δʹЩܲϣС
	// տִļĴСӦƳ
	// Ҫضʼ
	// ڴ洢õע
	// TODO: Ӧʵ޸ĸַ
	// ޸Ϊ˾֯
	SetRegistryKey(_T("ӦóɵıӦó"));

	init_param();
	load_conf();
	
    service_task_init();
	debug_server_init();
	debug_print_syslog(0, "Service thread, SQL thread, log thread Started.");
	//debug_server_process_thread_init();
	//g_hResOld = AfxGetResourceHandle();
	//AfxSetResourceHandle(g_hDll);
	CYAServerDlg dlg;
	m_pMainWnd = &dlg;

	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: ڴ˷ôʱ
		//  ȷرնԻĴ
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: ڴ˷ôʱ
		//  ȡرնԻĴ
	}

	// ɾ洴 shell 
	if (pShellManager != NULL)
	{
		delete pShellManager;
	}

	//AfxSetResourceHandle(g_hResOld);
	// ڶԻѹرգԽ FALSE Ա˳Ӧó
	//  ӦóϢá
	return FALSE;
}

/*
 * дļ
 *
 * param
 *		section	------		ֶ
 *		key     ------		ֵ
 *		value   ------		ֵ
 *
 * ӣ
 * [DB]
 * user=root
 * DBΪֶ userΪֵrootΪֵ
 *
 *
 * return
 *		
 *
*/
void CYAServerApp::writeini( string section, string key, string value )
{
	WritePrivateProfileStringA(section.c_str(), key.c_str(), value.c_str(), FILEPATH_SERVER_CONFIG);
}

/*
 * ݿúͱݿ
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::load_db_conf()
{
	IniFile ini;
	if(ini.open(FILEPATH_SERVER_CONFIG)){
		//ݿip
		dbhost = ini.read(CONF_SECT_DB, CONF_DB_KEY_HOST);
		//ݿû
		dbuser = ini.read(CONF_SECT_DB, CONF_DB_KEY_USER);
		//ݿ
		dbpwd = ini.read(CONF_SECT_DB, CONF_DB_KEY_PWD);
		//ݿݿ
		dbname = ini.read(CONF_SECT_DB, CONF_DB_KEY_DBNAME);
		//Ƿʹñݿ
		dbbackup = ini.read(CONF_SECT_DB, CONF_DB_KEY_DB_BACKUP);
		//ݿĶ˿
		dbport = atoi(ini.read(CONF_SECT_DB, CONF_DB_KEY_PORT).c_str());
		//ݿı
		dbencoding = ini.read(CONF_SECT_DB, CONF_DB_KEY_ENCODING);

		//ݿip
		dbhost_bk = ini.read(CONF_SECT_DB_BK, CONF_DB_KEY_HOST);
		//ݿû
		dbuser_bk = ini.read(CONF_SECT_DB_BK, CONF_DB_KEY_USER);
		//ݿ
		dbpwd_bk = ini.read(CONF_SECT_DB_BK, CONF_DB_KEY_PWD);
		//ݿݿ
		dbname_bk = ini.read(CONF_SECT_DB_BK, CONF_DB_KEY_DBNAME);
		//ݿ˿
		dbport_bk = atoi(ini.read(CONF_SECT_DB_BK, CONF_DB_KEY_PORT).c_str());
		//ݿ
		dbencoding_bk = ini.read(CONF_SECT_DB_BK, CONF_DB_KEY_ENCODING);
	}
}

/*
 * ݿúͱݿõļ
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::save_db_conf()
{
	char t[20];
	string s;
	sprintf_s(t, "%d", dbport);
	s = t;
	writeini(CONF_SECT_DB, CONF_DB_KEY_HOST, dbhost);
	writeini(CONF_SECT_DB, CONF_DB_KEY_USER, dbuser);
	writeini(CONF_SECT_DB, CONF_DB_KEY_PWD, dbpwd);
	writeini(CONF_SECT_DB, CONF_DB_KEY_DBNAME, dbname);
	writeini(CONF_SECT_DB, CONF_DB_KEY_DB_BACKUP, dbbackup);
	writeini(CONF_SECT_DB, CONF_DB_KEY_ENCODING, dbencoding);
	writeini(CONF_SECT_DB, CONF_DB_KEY_PORT, s);

	sprintf_s(t, "%d", dbport_bk);
	s = t;
	writeini(CONF_SECT_DB_BK, CONF_DB_KEY_HOST, dbhost_bk);
	writeini(CONF_SECT_DB_BK, CONF_DB_KEY_USER, dbuser_bk);
	writeini(CONF_SECT_DB_BK, CONF_DB_KEY_PWD, dbpwd_bk);
	writeini(CONF_SECT_DB_BK, CONF_DB_KEY_DBNAME, dbname_bk);
	writeini(CONF_SECT_DB_BK, CONF_DB_KEY_ENCODING, dbencoding_bk);
	writeini(CONF_SECT_DB_BK, CONF_DB_KEY_PORT, s);
}

/*
 * ļϵͳ
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::load_sys_conf()
{
	locate_type = 0;
	IniFile ini;
	send_json_postion = 1000;
	send_json_counting = 5000;
	send_json_alarm = 5000;
	warning_point_alarm = 10000;
	send_json_device = 10000;
	ws_connect_interval = 2000;
	time_send_call = 5000;
	time_send_help = 5000;
	send_json_drivingface = 30000;
	send_json_leader = 1800000; //30 * 60 * 1000;
	load_leader = 14400000; // 4 * 60 * 60 * 1000
	cal_vehicle_meeting = 5000;
	tcp_port = PORT_SERVER_MASTER;
	send_sync_time = 600000;
	shutdown_timeout_threshold = 480;
	vibrate_threshold = 50;

	if(ini.open(FILEPATH_SERVER_CONFIG)){
		ws_url = ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_WS_URL);
		ws_url_bk = ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_WS_URL_BK);
		tcp_host = ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_TCP_HOST);
		tcp_port = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_TCP_PORT).c_str());
		use_filter = (atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_USE_FILTER).c_str()) == 0 ? FALSE : TRUE);
		use_filter_odd = (atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_USE_FILTER_ODD).c_str()) == 0 ? FALSE : TRUE);
		recon_server = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_RECON_SERVER).c_str());
		recon_db = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_RECON_DB).c_str());
		reader_lost = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_READER_LOST).c_str());
		card_lost = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_CARD_LOST).c_str());
		timing_interval = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_TIMING_INTERVAL).c_str());
		sampling_interval = atof(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_SAMPLING_INTERVAL).c_str());
		coor_error = atof(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_COORDINATE_ERROR).c_str());
		ranging_error = atof(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_RANGING_ERROR).c_str());
		move_error = atof(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_MOVING_ERROR).c_str());
		z_offset = atof(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_Z_OFFSET).c_str());
		locate_type = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SERVER_LOCATE_TYPE).c_str());

		heart_interval = atoi(ini.read(CONF_SECT_SERVER_SETTING,CONF_SERVER_HEART_INTERVAL).c_str());
		send_json_postion = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_POSION).c_str());
		send_json_counting = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_COUNTING).c_str());
		send_json_alarm = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_ALARM).c_str());
		warning_point_alarm = atoi(ini.read(CONF_SECT_SERVER_SETTING,CONF_WARNING_POINT_ALARM).c_str());
		send_json_device = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_DEVICE).c_str());
		send_json_drivingface = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_DRIVINGFACE).c_str());
		send_json_leader = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_LEADER).c_str());
		load_leader = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_LOAD_LEADER).c_str());
		cal_vehicle_meeting = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_CAL_VEHICLE_MEETING).c_str());
		ws_connect_interval = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_WS_CONNECT_INTERVAL).c_str());
		time_send_call = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_CALLINFO_INTERVAL).c_str());
		time_send_help = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SEND_HELPINFO_INTERVAL).c_str());
		send_sync_time = atoi(ini.read(CONF_SECT_SERVER_SETTING,CONF_SEND_SYNC_TIME_INTERVAL).c_str());
		shutdown_timeout_threshold = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_SHUTDOWN_TIMEOUT_THRESHOLD).c_str());
		vibrate_threshold = atoi(ini.read(CONF_SECT_SERVER_SETTING, CONF_VIBRATE_THRESHOLD).c_str());
	}
}

/*
 * ϵͳõļ
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::save_sys_conf()
{
	char t[20];
	string s;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_WS_URL, ws_url);
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_WS_URL_BK, ws_url_bk);
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_USE_FILTER, use_filter ? "1" : "0");
	sprintf_s(t, "%d", recon_server);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_RECON_SERVER, s);
	sprintf_s(t, "%d", recon_db);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_RECON_DB, s);
	sprintf_s(t, "%d", reader_lost);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_READER_LOST, s);
	sprintf_s(t, "%d", card_lost);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_CARD_LOST, s);
	sprintf_s(t, "%d", timing_interval);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_TIMING_INTERVAL, s);
	sprintf_s(t, "%f", sampling_interval);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_SAMPLING_INTERVAL, s);
	sprintf_s(t, "%f", z_offset);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_Z_OFFSET, s);
	sprintf_s(t, "%f", coor_error);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_COORDINATE_ERROR, s);
	sprintf_s(t, "%f", ranging_error);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_RANGING_ERROR, s);
	sprintf_s(t, "%f", move_error);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_MOVING_ERROR, s);
	sprintf_s(t, "%d", tcp_port);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SERVER_TCP_PORT, s);
}

/*
 * ļ־
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::load_log_conf()
{
	IniFile ini;
	if(ini.open(FILEPATH_SERVER_CONFIG)){
		//ϵͳ״̬
		log_sys_status = (atoi(ini.read(CONF_SECT_SERVER_LOG, CONF_LOG_SYS_STATUS).c_str()) == 0 ? FALSE : TRUE);
		//ԭʼݣײ
		log_raw_data = (atoi(ini.read(CONF_SECT_SERVER_LOG, CONF_LOG_RAW_DATA).c_str()) == 0 ? FALSE : TRUE);
		//ʽ
		log_parse_data = (atoi(ini.read(CONF_SECT_SERVER_LOG, CONF_LOG_PARSE_DATA).c_str()) == 0 ? FALSE : TRUE);
		//ݰ
		log_send_package = (atoi(ini.read(CONF_SECT_SERVER_LOG, CONF_LOG_SEND_EVENT).c_str()) == 0 ? FALSE : TRUE);
		//ݰ
		log_recv_package = (atoi(ini.read(CONF_SECT_SERVER_LOG, CONF_LOG_REV_EVENT).c_str()) == 0 ? FALSE : TRUE);
		//λ
		log_locate_data = (atoi(ini.read(CONF_SECT_SERVER_LOG, CONF_LOG_LOCATE_DATA).c_str()) == 0 ? FALSE : TRUE);
	}
}

/*
 * ־
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::save_log_conf()
{
	writeini(CONF_SECT_SERVER_LOG, CONF_LOG_SYS_STATUS, log_sys_status ? "1" : "0");
	writeini(CONF_SECT_SERVER_LOG, CONF_LOG_RAW_DATA, log_raw_data ? "1" : "0");
	writeini(CONF_SECT_SERVER_LOG, CONF_LOG_PARSE_DATA, log_parse_data ? "1" : "0");
	writeini(CONF_SECT_SERVER_LOG, CONF_LOG_SEND_EVENT, log_send_package ? "1" : "0");
	writeini(CONF_SECT_SERVER_LOG, CONF_LOG_REV_EVENT, log_recv_package ? "1" : "0");
	writeini(CONF_SECT_SERVER_LOG,CONF_LOG_LOCATE_DATA,log_locate_data ? "1" : "0");
}

/*
 * üطԼ·
 *
 * param
 *		hwd ------	Ի򴰿ھ	
 *
 * return
 *		
 *
*/
void CYAServerApp::set_server_handle(HWND hwd)
{
	char t[20];
	char szAppdir[MAX_PATH+1] = {0};
	GetModuleFileNameA(NULL, szAppdir , MAX_PATH);
	sprintf_s(t, "%d", DWORD(hwd));
	writeini(CONF_SECT_MONITOR, CONF_MONITOR_SERVER_HANDLE, t);
	writeini(CONF_SECT_MONITOR, CONF_MONITOR_SERVER_PATH, szAppdir);
}

/*
 * ļ
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::load_monitor_conf()
{
	IniFile ini;
	if(ini.open(FILEPATH_SERVER_CONFIG)){
		m_hwnd_monitor = HWND(atoi(ini.read(CONF_SECT_MONITOR, CONF_MONITOR_MONITOR_HANDLE).c_str()));
		string path = ini.read(CONF_SECT_MONITOR, CONF_MONITOR_MONITOR_PATH);
		sprintf_s(m_path_monitor.get(), MAX_PATH, "%s", path.c_str());
		//sprintf( m_path_monitor, "%s", path.c_str());
	}
}

/*
 * ʼ·
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::init_param()
{
	m_path_monitor = nullptr;
	std::unique_ptr<char> tmp(new char[MAX_PATH]);
	m_path_monitor = std::move(tmp);
	memset(m_path_monitor.get(),0,MAX_PATH*sizeof(char));
}

/*
 * õļ
 *
 * param
 *		
 *
 * return
 *		
 *
*/
void CYAServerApp::save_interval_conf()
{
	char t[20];
	string s;
	sprintf_s(t, "%d", send_json_postion);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_POSION, s);
	sprintf_s(t, "%d", send_json_counting);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_COUNTING, s);
	sprintf_s(t, "%d", send_json_alarm);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_ALARM, s);
	sprintf_s(t, "%d", send_json_device);
	s = t;
	writeini(CONF_SECT_SERVER_SETTING, CONF_SEND_JSON_DEVICE, s);
}

void CYAServerApp::load_reader_conf()
{
	IniFile ini;
	if(ini.open(FILEPATH_SERVER_CONFIG)){
		//վʱϢ
		reader_interval_time = atoi(ini.read(CONF_SECT_READER, CONF_READER_INTERVAL_TIME).c_str());
	}
}

void CYAServerApp::save_reader_conf()
{
	char t[20] = {0};
	string s;
	sprintf_s(t, "%d", reader_interval_time);
	s = t;
	writeini(CONF_SECT_READER, CONF_READER_INTERVAL_TIME, s);
}

BOOL CYAServerApp::KillProcessFromName(CString strProcessName)
{
	//̿(TH32CS_SNAPPROCESSʾн̵Ŀ)  
	HANDLE hSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);  

	//PROCESSENTRY32̿յĽṹ  
	PROCESSENTRY32 pe;  

	//ʵʹProcess32FirstȡһյĽǰĳʼ  
	pe.dwSize = sizeof(PROCESSENTRY32);  


	//IFЧͬ:  
	//if(hProcessSnap == INVALID_HANDLE_VALUE)   Чľ  
	if(!Process32First(hSnapShot,&pe))  
	{  
		return FALSE;  
	}  

	//ַתΪСд  
	strProcessName.MakeLower();  

	//Ч  һֱȡһѭȥ  
	while (Process32Next(hSnapShot,&pe))  
	{  

		//pe.szExeFileȡǰ̵Ŀִļ  
		CString scTmp = pe.szExeFile;  


		//ִļӢĸ޸ΪСд  
		scTmp.MakeLower();  

		//Ƚϵǰ̵ĿִļƺʹݽļǷͬ  
		//ͬĻCompare0  
		if(!scTmp.Compare(strProcessName))  
		{  

			//ӿսлȡý̵PID(еPID)  
			DWORD dwProcessID = pe.th32ProcessID;  
			HANDLE hProcess = ::OpenProcess(PROCESS_TERMINATE,FALSE,dwProcessID);  
			::TerminateProcess(hProcess,0);  
			CloseHandle(hProcess);  
			return TRUE;  
		}  
		scTmp.ReleaseBuffer();  
	}  
	strProcessName.ReleaseBuffer();  
	return FALSE;  
}

void CYAServerApp::load_conf()
{
	load_db_conf();
	load_sys_conf();
	load_log_conf();
	load_reader_conf();
}
