#ifndef FITTING_POSITION_H
#define FITTING_POSITION_H

#include <vector>

namespace Fitting{
	
	#define REF_POSITION_NUM 5		//ο
	#define FIT_POSITION_NUM 5		//Ҫɵݸһεct

	double sum(double * dNumarry,int n);
	double Sum(std::vector<double> vt_num,int n);
	double MutilSum(double* dX,double *dY,int n); 
	double MutilSum(std::vector<double> vx,std::vector<double> vy,int n);
	double RelatePow(double *dx,int n,int ex);  
	double RelatePow(std::vector<double> vx, int n, int ex);  
	double RelateMutiXY(double *dx,double*dy,int n,int ex); 
	double RelateMutiXY(std::vector<double> vx, std::vector<double> vy, int n, int ex);  
	void EMatrix(double *dx,double*dy,int n,int ex,double coefficient[]);  
	void EMatrix(std::vector<double> vx, std::vector<double> vy, int n, int ex, double coefficient[]); 
	void CalEquation(int exp,double coefficient[] );  
	double F(double c[],int l,int m);   
	double F(std::vector<double> vc,int l,int m);  
	double polyval(double* y,double x);
	double polyval(std::vector<double> vt,double v);
	double VAR(double *);
	double VAR(std::vector<double> vt);
};

#endif