//#pragma once
#ifndef KALMAN_FILTER_H
#define KALMAN_FILTER_H

#include <Eigen/Dense>

//ڿ˲
const int READER_NUMS = 4;
const int OBSERVATION_NUMS = 4;

class Car;

class CKalmanFilter{
public:
	Car* m_pCar;
public:
	bool m_bFlag;	//λ־λ
	int  m_nCounts; //λɹ
public:
	CKalmanFilter();
	~CKalmanFilter();
public:
	void Initial(double t);
	void Predict(double t);
	void Predict_Correct(double t);
};

class Car
{	
public:	
	double t;
	Eigen::Matrix<double, READER_NUMS, READER_NUMS,Eigen::DontAlign> A;
	//˲棬0 - 3 ֱxλ x ٶ y yٶ
	Eigen::Matrix<double, READER_NUMS, 1,Eigen::DontAlign> x;
	Eigen::Matrix<double, READER_NUMS, READER_NUMS,Eigen::DontAlign> P;
	Eigen::Matrix<double, READER_NUMS, READER_NUMS,Eigen::DontAlign> Q;
	Eigen::Matrix<double, OBSERVATION_NUMS, OBSERVATION_NUMS,Eigen::DontAlign> H;
	Eigen::Matrix<double, OBSERVATION_NUMS, OBSERVATION_NUMS,Eigen::DontAlign> R;
	//ԭʼλ0 - 3 ֱxλ x ٶ y yٶ
	Eigen::Matrix<double, OBSERVATION_NUMS, 1,Eigen::DontAlign> z;
public:
	//EIGEN_MAKE_ALIGNED_OPERATOR_NEW			//ݽṹ
};

#endif