#pragma once

#include <sys/timeb.h>
#include <memory>
using namespace std;

namespace nspLocate{

	const int PERIOD_SYNCTIME = 15000; // վʱͬڣԼ10룬10000
	const double INTERVAL_SYNCTIME = 200.0; // վʱͬ200
	const unsigned long long PERIOD_MAX_VALUE = 0xFFFFFFFFFF;
	const double PICOSECOND_COEFFICIENT = (15.65 * 1E-9);

	class LocateRecord
	{
	private:
		// վձʶʱ䣬ΪԲֵʱ䣬վУԲ㷨СʱΪ׼
		unsigned long long locateTime;
		// μ¼ʱķվ
		int readerId ;
		// μ¼վʱͬ
		int syncNum; 
		// ʱ
		int cardTimestamp;
		// λʱ䣬൱time(NULL)
		unsigned long long receiveTime;		
		//// ǰ
		//double x; 
		//double y;
		//// ǰٶ
		//double vx;
		//double vy;
		//double v; // ٶ
		//double a; // ٶ
		//// ͼתΪ
		//double scale;

		int deltaT;

		// ǰʱ䣬197011յڵĺ
		unsigned long long millionSeconds(){
			struct timeb t1;
			ftime(&t1);
			return t1.millitm;  // 
			//t1.time //  ͬtime(NULL);
		}
	public:
		LocateRecord(void){}
		LocateRecord(unsigned long long revTime, int rid, int sn, int ct){
			this->locateTime = revTime;
			this->readerId = rid;
			this->syncNum = sn;
			this->cardTimestamp = ct;
			this->receiveTime = millionSeconds();
			deltaT = 0;
		}
		~LocateRecord(void){}

		//// ϴεʱ䡢λüٶȡٶ
		//void getV(std::shared_ptr<LocateRecord> &lr){
		//	double deltaT = getDeltaT(lr) / 1000.0; // תΪ
		//	// ʱ쳣ӦĬֵ
		//	if(0 == deltaT)
		//	{
		//		vx = lr->VX();
		//		vy = lr->VY();
		//		v = lr->V();
		//		a = lr->A();
		//	}
		//	else
		//	{
		//		// ٶȣٶ
		//		vx = (x - lr->X()) * scale / deltaT;
		//		vy = (y - lr->Y()) * scale / deltaT;
		//		v = sqrt(pow(vx, 2) + pow(vy, 2));

		//		double avx = (vx - lr->VX()) / deltaT;
		//		double avy = (vy - lr->VY()) / deltaT;
		//		a = sqrt(pow(avx,2) + pow(avy,2));
		//	}
		//}
		//void SetReceiveTime(){ receiveTime = millionSeconds();}
		//void SetScale(double val){ scale = val;}

		unsigned long long ReceiveTime() const { return receiveTime; }
		unsigned long long LocateTime() const { return locateTime;}
		int SyncNum() const { return syncNum;}
		int CardTimestamp() const { return cardTimestamp;}
		int ReaderId() const { return readerId ;}

		int DeltaT() const { return deltaT; } // 
		double DeltaTSecond() const {return (double)deltaT/1000.0;}; // 
		// ȡζλʱغ
		void getDeltaT(std::shared_ptr<LocateRecord> &lr)
		{
			if(nullptr == lr)
			{
				return ;
			}
			unsigned long long ret = receiveTime - lr->ReceiveTime();
			// ʱͬˣλʱreceiveTimeΪ׼
			if( ret > PERIOD_SYNCTIME)
			{
				deltaT = (int)ret;
			}
			// ʱͬŲ500ϣΪroot쳣ʱͬãλʱreceiveTimeΪ׼
			else if((syncNum - lr->SyncNum())*INTERVAL_SYNCTIME > PERIOD_SYNCTIME) // 500
			{
				deltaT = (int)ret;
			}
			// վʱڣһڣԷվʱΪ
			else if(locateTime < lr->LocateTime())
			{
				deltaT = (int)(((locateTime + PERIOD_MAX_VALUE - lr->LocateTime()) & PERIOD_MAX_VALUE) * PICOSECOND_COEFFICIENT);
			}
			// ͬһڣԷվʱΪ׼
			else
			{
				deltaT = (int)(((locateTime - lr->LocateTime()) & PERIOD_MAX_VALUE) * PICOSECOND_COEFFICIENT);
			}
		}

		//double VX() const { return vx;}
		//double VY() const { return vy;}
		//double V() const { return v;}
		//double A() const { return a;}

		//double X() const { return x;}
		//double Y() const { return y;}
	};
}
