#include "stdafx.h"
#include "locate_algorithm.h"
#include <math.h>
#include <algorithm>
#include "../common/matrix/_Matrix.h"
#include "../common/Functions/Functions.h"

#include "ProcessRemodule.h"
#include "log_process_module.h"

using namespace std;

// ant ߣ tarλĿ꣬ d 
void AOAformula( struct _coordinate* ant, double angle, struct _coordinate* tar, bool is_line /*= false*/, double z_offset /*= 0*/ )
{
	double aa = sin(angle);
	double bb = cos(angle);
	double h = ant->z;
	if(is_line){
		h = z_offset;
	}
	tar->x = ant->x + sqrt(ant->d * ant->d - h * h) * cos(angle); 
	tar->y = ant->y + sqrt(ant->d * ant->d - h * h) * sin(angle);
	tar->z = ant->z; // ߶
	tar->a = ant->a; // Ƕ
	tar->t = ant->t; // ʱ
	tar->d_offset = ant->d_offset;
	tar->reader_id = ant->reader_id;
	tar->d = ant->d;
}

// ant ߣ last ϴ
double Distanceformula( struct _coordinate* ant, struct _coordinate* last )
{
	double x0,y0;
	double tan_diff = tan(last->a) - tan(ant->a);
	double ret = 0;
	if(tan_diff == 0){
		ret = sqrt((ant->x - last->x) * (ant->x - last->x) +  (ant->y - last->y) * (ant->y - last->y));
	}else{
		x0 = (last->x * tan(last->a) - ant->x * tan(ant->a) + ant->y - last->y) / (tan(last->a) - tan(ant->a));
		y0 = (((last->x - ant->x) * tan(last->a) * tan(ant->a)) + ant->y * tan(last->a) - last->y * tan(ant->a)) / (tan(last->a) - tan(ant->a));
		ret = sqrt((x0 - ant->x) * (x0 - ant->x) + (y0 - ant->y) * (y0 - ant->y)) 
			+ sqrt((x0 - last->x) * (x0 - last->x) + (y0 - last->y) * (y0 - last->y));
	}
	// n = Nodeformula( n1, n2);
	return ret;
}

// յ
void algorithm_locate( struct _coordinate** coor_list, int coor_size, struct _coordinate* hist, struct _coordinate* dest, double dist_limit, double z_offset)
{
	double d0;  //ʷλʵʱλ֮ľ룻
	double dN;  //Vʱۼн룻
	double Angle1,Angle2,Angle3;  //ʱκ2ĽǶ
	double Angle;   //֮ĽǶ
	double dLong;
	double dLenth;
	int position;  //λλ

	switch(coor_size){		
	case 1: // 1λݣ5.3.1
		{
			if(coor_list[0]->d > dist_limit){ // ľĳ̶ֵ,ʱжϴλ߽Ƕһ
				//coor_list[0]->d -= coor_list[0]->d_offset;
				AOAformula(coor_list[0], coor_list[0]->a, dest, true, z_offset);
			}else { // Сĳֵ
				//Vʱۼн
				dN = coor_list[0]->v * (coor_list[0]->t - hist->t);
				//ʵʱλվߣʷλ֮ľ
				d0 = Distanceformula(coor_list[0], hist);
				if(hist->x - coor_list[0]->x == 0){
					Angle = (coor_list[0]->y >= hist->y) ? 90 : 270;
					Angle = Angle * M_PI / 180;
				}else{
					//ʷʵʱվĽǶȣʷλڶλķ
					Angle = atan((hist->y - coor_list[0]->y)/(hist->x - coor_list[0]->x));
				}

				// ʷͬ		
				//λС֮ľ룬˵λλ֮
				if(d0 >= coor_list[0]->d){
					if(dN >= coor_list[0]->d){
						Angle += M_PI;  //ʷ귴
					}
				}else{  
					//λ֮ľ룬˵λλ֮,ֻҪжĸyuλü
					//۽о֮ľ룬˵ʷͬһ򣬷֮ڷ
					if(dN < coor_list[0]->d){ 
						Angle += M_PI;  //ʷ귴
					}
				}
				//coor_list[0]->d -= coor_list[0]->d_offset;
				AOAformula(coor_list[0], Angle, dest, true, z_offset);  //նλ
			}
			break;
		}
	case 2: //2λݣ5.3.2
		{
			//2λзվ()ʷλ֮ĽǶȣԴƳǷһֱϻ߳
			if(coor_list[0]->x == hist->x ){
				Angle1 = (coor_list[0]->y == hist->y) ? 0 : ((coor_list[0]->y > hist->y) ? 90 : 270);
				Angle1 = Angle1 * M_PI / 180;
			}else{
				Angle1 = atan((coor_list[0]->y - hist->y) / (coor_list[0]->x - hist->x)); 
			}
			if(coor_list[1]->x == hist->x ){
				Angle2 = (coor_list[1]->y == hist->y) ? 0 : ((coor_list[1]->y > hist->y)? 90 : 270);
				Angle2 = Angle2 * M_PI / 180;
			}else{
				Angle2 = atan((coor_list[1]->y - hist->y) / (coor_list[1]->x - hist->x)); 
			}
			if(coor_list[1]->x == coor_list[0]->x ){
				Angle3 = (coor_list[1]->y >= coor_list[0]->y) ? 90 : 270; // ڲͬ
				Angle3 = Angle3 * M_PI / 180;
			}else{
				Angle3 = atan((coor_list[1]->y - coor_list[0]->y) / (coor_list[1]->x - coor_list[0]->x)); 
				if(Angle3 > M_PI){
					Angle3 -= M_PI;
				}
				/*if(coor_list[0]->x > coor_list[1]->x)
				Angle3 += M_PI;*/
			}
			//2Ƕͬ180˵һֱ
			//if(coor_list[0]->a == coor_list[1]->a || coor_list[0]->a == coor_list[1]->a + M_PI || coor_list[0]->a == coor_list[1]->a - M_PI){
			if(Angle1 == Angle2 || Angle1 == Angle2 + M_PI || Angle1 == Angle2 - M_PI){
				//ȡֵ֮,̾Ϊλ
				dLong = max(coor_list[0]->d, coor_list[1]->d);
				position = (coor_list[0]->d > coor_list[1]->d) ? 1 : 0;
				dLenth = Distanceformula(coor_list[0], coor_list[1]);
				if(dLong > dLenth){
					Angle = Angle3 + ((position + 1)%2) * M_PI; 
				}else{
					Angle = Angle3 +  position * M_PI;
				}
				//2ľС2еֵ˵λ2࣬
				//ھ̵Ϊλ꣬λǶͬ
				//2ľеκһ˵λ֮䣬ȡһΪλ,λǶǶ෴+180
				// AOAformula(coor_list[position], Angle, dest);  //նλ

				// ݲĽd 
				// x2 - (d2 - ((d1+d2) - (x2-x1))/2) x2  x2 > x1,d1 > d2
				// x1 + (d1 - ((d1+d2) - (x2-x1))/2) x1  x2 > x1,d1 < d2
				// õ (x1 + x2 + d1 - d2)/2
				// ʾd = ((d1 + d2) - abs(x2-x1))/2
				double d_offset;
				if(fabs(coor_list[0]->x - coor_list[1]->x) > fabs(coor_list[0]->y - coor_list[1]->y)){ // ˮƽ
					d_offset = (coor_list[0]->d + coor_list[1]->d - fabs(coor_list[0]->x - coor_list[1]->x))/2;
				}else{ // ֱ
					d_offset = (coor_list[0]->d + coor_list[1]->d - fabs(coor_list[0]->y - coor_list[1]->y))/2;
				}
				dest->d_offset = d_offset;
				coor_list[0]->d_offset = d_offset;
				coor_list[1]->d_offset = d_offset;
				coor_list[position]->d -= d_offset;
				AOAformula(coor_list[position], Angle, dest, true, z_offset);
			}
			//·ʽ
			else {
				dLenth = Distanceformula(coor_list[0], coor_list[1]); //2֮ľ
				if(dLenth > (coor_list[0]->d  + coor_list[1]->d)) { //ȡһΪλοݣ1λ㷨,ο5.3.1
					//ľĳ̶ֵ,ʱжϴλ߽Ƕһ£
					if(coor_list[0]->d > dist_limit){
						AOAformula(coor_list[0], coor_list[0]->a, dest);  //նλ
					}
					//Сĳֵ
					else{
						dN = coor_list[0]->v * ( hist->t - coor_list[0]->t);  //Vʱۼн룻
						d0 = Distanceformula(coor_list[0], hist);  //ʵʱλվߣʷλ֮ľ
						if(hist->x == coor_list[0]->x){
							Angle = (hist->y >= coor_list[0]->y) ? 90 : 270; //ʷʵʱվĽǶȣʷλڶλķ
							Angle = Angle * M_PI / 180;
						}else{
							Angle = atan((hist->y - coor_list[0]->y) / (hist->x - coor_list[0]->x));
						}

						//λС֮ľ룬˵λλ֮
						if(d0 > coor_list[0]->d){
							if(dN >= coor_list[0]->d){
								Angle += M_PI; //ʷ귴
							}
						}
						else{
							//λ֮ľ룬˵λλ֮,ֻҪжĸλü
							//۽о֮ľ룬˵ʷͬһ򣬷֮ڷ
							if(dN < coor_list[0]->d){
								Angle += M_PI;
							}
						}
						AOAformula(coor_list[0], Angle, dest, true, z_offset);  //նλ
					}
				}
				else { //2λ㷨5.3.2				
					//ȡֵ֮,̾Ϊλ
					dLong = max(coor_list[0]->d, coor_list[1]->d);
					position = (coor_list[0]->d > coor_list[1]->d) ? 1 : 0;
					dLenth = Distanceformula(coor_list[0], coor_list[1]);
					//2ľС2еֵ˵λ2࣬
					//ھ̵Ϊλ꣬λǶͬ
					//2ľеκһ˵λ֮䣬ȡһΪλ,λǶǶ෴
					if(dLong > dLenth){
						Angle = Angle3 + ((position + 1)%2) * M_PI; 
					}else{
						Angle = Angle3 +  position * M_PI;
					}
					AOAformula(coor_list[position], Angle, dest, true, z_offset);  //նλ
				}
			}
			break;
		}
	case 3: // 3λݣ㶨λ 
		{
			// ͬһֱϲʹ㶨λ
			locatebycordinate(coor_list, dest);

			break;
		}
	case 4: // 4ݣȡǰ3
		{
			locatebycordinate(coor_list, dest);
			break;
		}
	default:
		{
			dest->x = -1;
			dest->y = -1;
			dest->a = 0;
			break;
		}
	}
}

void locatebycordinate( struct _coordinate** coor_list, struct _coordinate* dest )
{
	double h = 0;
	int i = 0;
	int j = 0;
	double temp = 0;

	double x[3]; // 
	double y[3]; // 
	double z[3];
	double d[3];
	double p[2]; 
	_Matrix pi;

	matrix_set(&pi,3,2);
	matrix_init(&pi);

	for(i=0;i<3;i++){
		x[i] = coor_list[i]->x;
		y[i] = coor_list[i]->y;
		z[i] = coor_list[i]->z;
		d[i] = coor_list[i]->d; // d * CM_PIX * 100;
	}
	//
	matrix_write(&pi,0,0,x[0]);
	matrix_write(&pi,0,1,y[0]);
	h = z[0];
	d[0] = sqrt(d[0] * d[0] - h * h);

	matrix_write(&pi,1,0,x[1]);
	matrix_write(&pi,1,1,y[1]);
	h = z[1];
	d[1] = sqrt(d[1] * d[1]- h * h);

	matrix_write(&pi,2,0,x[2]);
	matrix_write(&pi,2,1,y[2]);
	h = z[2];
	d[2] = sqrt(d[2] * d[2] - h * h);

	if (locate_func(&pi,d,p) > 0)
	{
		dest->x = p[0];
		dest->y = p[1];
	}else
	{
		dest->x = -1;
		dest->y = -1;
	}
}

void algorithm_locate_ex( _coordinate** coor_list, int coor_size, _coordinate* hist, _coordinate* dest, double dist_limit )
{
	switch (coor_size)
	{
	case 1:
		{
			if(!hist){ // μ㣬ֻһվݵʱ
				return;
			}
			// ȡʷڵ뵱ǰվĽǶȣжǷͬһֱ
			double angle = getAngleByAngle(coor_list[0], hist);
			if(0 == tan(angle)){ // ͬһֱ
				double dist_temp = getDistance(hist, coor_list[0]); // һεľ
				// ƶľ
				double dist_mv = fabs(dist_temp - coor_list[0]->d);
				// ԭƶ˶
				calcCoordinate(hist, dist_mv, hist->a, dest); //
			}else{ // нǶȣҽ
				_coordinate* pt_cross = getCross(hist, coor_list[0]);
				double dist_temp = getDistance(pt_cross, coor_list[0]);
				if(dist_temp >= coor_list[0]->d){
					// ⶯ǽȽõ㶨λ
					dest->x = pt_cross->x;
					dest->y = pt_cross->y;
					dest->z = coor_list[0]->z;
					dest->a = getAngleByCoordinate(pt_cross, coor_list[0]); // з
				}else{ // ڵǰ, ϲ
					dist_temp = (getDistance(hist, pt_cross) - (coor_list[0]->d - dist_temp)); // λ
					calcCoordinate(hist, dist_temp, hist->a, dest);
				}
			}
			break;
		}
	case 2:
		{
			double angle_anc = getAngleByAngle(coor_list[0], coor_list[1]);
			if(0 == tan(angle_anc)){ // ͬһֱ
				double dist_anc = getDistance(coor_list[0], coor_list[1]);
				double dist_offset;
				if(dist_anc < coor_list[0]->d || dist_anc < coor_list[1]->d ) {//վʶľڷվ֮ľ룬ͬһ
					dist_offset = fabs(coor_list[0]->d - coor_list[1]->d) - dist_anc;
					double angle_anc_run = getAngleByCoordinate(coor_list[0], coor_list[1]); // վ2һ
					if(coor_list[0]->d < coor_list[1]->d){ // վ1һ
						angle_anc_run += M_PI;
					}
					calcCoordinate(coor_list[0], coor_list[0]->d - dist_offset / 2, angle_anc_run, dest);
				}else{ //ڷվ֮
					dist_offset = coor_list[0]->d + coor_list[1]->d - dist_anc;
					calcCoordinate(coor_list[0], coor_list[0]->d + dist_offset / 2, getAngleByCoordinate(coor_list[0], coor_list[1]), dest);
				}
			}else{ // мн, һվ֮
				if(hist){
					double angle_anc1 = getAngleByAngle(coor_list[0], hist);
					double angle_anc2 = getAngleByAngle(coor_list[1], hist);
					// ҵ
					_coordinate* pt_cross = getCross(coor_list[0], coor_list[1]);
					// 㵽վľ
					double dist_anc1 = getDistance(pt_cross, coor_list[0]);
					double dist_anc2 = getDistance(pt_cross, coor_list[1]);

					if(0 == tan(angle_anc1)){
						if(dist_anc1 >= coor_list[0]->d){ // ֱΪ׼
							calcCoordinate(hist, fabs(dist_anc1 - coor_list[0]->d), hist->a, dest);
							//calcCoordinate(coor_list[0], coor_list[0]->d, getAngleByCoordinate(coor_list[0], hist), dest);
						}else{ // ֱӶλ
							dest->x = pt_cross->x;
							dest->y = pt_cross->y;
							dest->a = getAngleByCoordinate(pt_cross, coor_list[1]);
						}
					}else if(0 == tan(angle_anc2)){ // վ1ͬһֱ
						if(dist_anc2 >= coor_list[1]->d){ // ֱΪ׼
							calcCoordinate(hist, fabs(dist_anc2 - coor_list[1]->d), hist->a, dest);
							//calcCoordinate(coor_list[1], coor_list[1]->d, getAngleByCoordinate(coor_list[1], hist), dest);
						}else{ // ֱӶλ
							dest->x = pt_cross->x;
							dest->y = pt_cross->y;
							dest->a = getAngleByCoordinate(pt_cross, coor_list[0]);
						}
					}else { // 
						// ҵ
						_coordinate* pt_cross1 = getCross(hist, coor_list[0]);
						_coordinate* pt_cross2 = getCross(hist, coor_list[1]);

						if(coor_list[0]->d >= coor_list[1]->d){
							dest->x = pt_cross2->x;
							dest->y = pt_cross2->y;							
							dest->z = coor_list[1]->z;
							dest->a = coor_list[1]->a;
						}else{
							dest->x = pt_cross1->x;
							dest->y = pt_cross1->y;							
							dest->z = coor_list[0]->z;
							dest->a = coor_list[0]->a;
						}
					}
				}else{ // ȶλ,⴩ǽ
					_coordinate* pt_cross = getCross(coor_list[0], coor_list[1]);
					dest->x = pt_cross->x;
					dest->y = pt_cross->y;
					// ȽϾ,λķ
					if(fabs(getDistance(pt_cross, coor_list[0]) - coor_list[0]->d) >= fabs(getDistance(pt_cross, coor_list[1]) - coor_list[1]->d)){
						dest->z = coor_list[1]->z;
						dest->a = coor_list[1]->a;
					}else{
						dest->z = coor_list[0]->z;
						dest->a = coor_list[0]->a;
					}
				}
			}
			break;
		}
	case 3:
		{
			// жϷվǷͬһֱ
			if(is_all_inline(coor_list, coor_size)){
				algorithm_locate_ex(coor_list, 2, hist, dest, dist_limit);
				break;
			}
			locatebycordinate(coor_list, dest);
			break;
		}
	case 4:
		{
			// жϷվǷͬһֱ
			if(is_all_inline(coor_list, coor_size)){
				algorithm_locate_ex(coor_list, 2, hist, dest, dist_limit);
				break;
			}
			locatebycordinate(coor_list, dest);
			break;
		}
	default:
		break;
	}
}

double getAngleByAngle( _coordinate* p1, _coordinate* p2 )
{
	if(p1->x == p2->x) return 0;
	if(p1->y == p2->y) return 0;
	return double(p2->a - p1->a);
}

double getAngleByCoordinate( _coordinate* p1, _coordinate* p2 )
{
	if(p1->x == p2->x && p1->y == p2->y){ // ȣԽ۷
		return p1->a;
	}
	if(p1->x == p2->x){
		if(p1->y >= p2->y){
			return M_PI_2 * 3;
		}
		return M_PI_2;
	}
	if(p1->y == p2->y){
		if(p1->x > p2->x){
			return M_PI;
		}
		return 0;
	}
	return atan((p2->y - p1->y) / (p2->x - p1->x));
}

_coordinate* getCross( _coordinate* p1, _coordinate* p2 )
{
	_coordinate* p = new _coordinate; 
	double b1 = p1->y - tan(p1->a) * p1->x;
	double b2 = p2->y - tan(p2->a) * p2->x;

	if(p1->a == 0 || p1->a == M_PI){ // һˮƽ
		p->y = p1->y;
		if(p2->a == M_PI_2 || p2->a == M_PI_2 * 3){ // ڶ㴹ֱ
			p->x = p2->x;
		}else{ // ڶнǶ
			p->x = (p->y - b2) / tan(p2->a);
		}
		return p;
	}else if(p1->a == M_PI_2 || p1->a == M_PI_2 * 3){ // һ㴹ֱ
		p->x = p1->x;
		if(p2->a == 0 || p2->a == M_PI){ // ڶˮƽ
			p->y = p2->y;
		}else{ // ڶнǶ
			p->y = tan(p2->a) * p->x + b2;
		}
		return p;
	}else { // нǶ
		if(p2->a == 0 || p2->a == M_PI){ // ڶˮƽ
			p->y = p2->y;
			p->x = (p->y - b1) / tan(p1->a);
			return p;
		}else if(p2->a == M_PI_2 || p2->a == M_PI_2 * 3){ // ڶ㴹ֱ
			p->x = p2->x;
			p->y = p->x * tan(p1->a) + b1;
			return p;
		}
	}
	p->x = (b1-b2)/(tan(p2->a) - tan(p1->a));
	p->y = tan(p1->a) * p->x + b1;
	return p;
}

// ۷
void calcCoordinate( _coordinate* p1, double dist, double angle, _coordinate* dest )
{
	dest->x = p1->x;
	dest->y = p1->y;
	dest->z = p1->z;

	dest->x += dist * cos(angle);
	dest->y += dist * sin(angle);

	dest->a = angle;
}

double getDistance( _coordinate* p1, _coordinate *p2 )
{
	return sqrt(pow(p1->x - p2->x, 2) + pow(p1->y - p2->y, 2));
}

bool is_all_inline( _coordinate** coor_list, int cnt )
{
	bool ret = false;
	if(cnt < 3) return ret;
	if(coor_list[0]->x == coor_list[1]->x && coor_list[0]->x == coor_list[2]->x){
		ret = true;
	}else if(coor_list[0]->y == coor_list[1]->y && coor_list[0]->y == coor_list[2]->y){
		ret = true;
	}else{
		ret = false;
	}	
	return ret;
}

POS* LocateAlgorithm::Pos(ReaderPathMap rpm,int sta_num,int ant,double dist,INFO_PRE info_pre)
{
	POS* p = new POS;
	p->posx = 0;
	p->posy = 0;
	p->pos_radius = 999999.9; //infmatlabбʾ

	double d[2];
	double xcross[2];
	double ycross[2];

	int seg_num = 0;

	if(rpm.find(sta_num) == rpm.end())
	{
		return NULL;
	}
	seg_num = rpm.find(sta_num)->second->nRealCalcPoints - 1;

	if(seg_num < 0 ){
		return NULL;
	}

	int j = 0;
	for(int i =0;i<seg_num;i++){

		if(rpm.find(sta_num)->second->px[i]==-1||rpm.find(sta_num)->second->px[i+1]==-1)
		{
			continue;
		}

		SOLUTION *r = NULL;
		r = GetPos(rpm,sta_num,ant,dist,i);
		
		if(r == NULL){
			continue;
		}
		//xcountȡ2ΪΪ2
		int count = 2; 
		for(j =0;j<2;j++){
			xcross[j] = r->x[j];
			ycross[j] = r->y[j];
		}

		for(j = 0;j < count;j++){
			double d1 = xcross[j] - rpm.find(info_pre.sta_num)->second->x[info_pre.ant];
			double d2 = ycross[j] - rpm.find(info_pre.sta_num)->second->y[info_pre.ant];
			d[j] = sqrt(pow(d1,2) + pow(d2,2));
		}
		for(j = 0;j < count;j++){
			d[j] = fabs(d[j] - info_pre.dist);
		}

		double c = 999999.9;
		int k = -1;
		for(j = 0;j < count;j++){
			if(d[j] < c){
				c = d[j];
				k = j;
			}
		}

		if(c<p->pos_radius){
			p->posx = xcross[k];
			p->posy = ycross[k];
			p->pos_radius = c;
		}
	}

	return p;
}

/*
 * TOFλ·μָվΪԲĵ
 *
 * param
 *		trpm			tofͼ·
 *		reader_id		վid
 *		antenna_id		վ
 *		dist			˷վߵľ
 *		refer_data		οϢ
 *
 * return
 *		ضλ꣬޷nullptr
 *
*/
std::shared_ptr<POS> LocateAlgorithm::tof_locate_1d(std::shared_ptr<TOFReaderPathMap> trpm,int reader_id,int antenna_idx,double dist,TOF_REFER_DATA refer_data)
{
	std::shared_ptr<POS> p = std::make_shared<POS>();

	double d[MAX_READER_TDOA_PATH_NUMS] = {0};
	double xcross[MAX_READER_TDOA_PATH_NUMS] = {0};
	double ycross[MAX_READER_TDOA_PATH_NUMS] = {0};

	int seg_num = 0;

	if(trpm->find(reader_id) == trpm->end() || trpm->find(refer_data.nReaderId) == trpm->end())
	{
		return nullptr;
	}
	seg_num = trpm->find(reader_id)->second->nRealCalcPoints - 1;
	//ж·ĵǷ㣬ſԹ߶·
	if(seg_num < 0 ){
		return nullptr;
	}

	int j = 0;
	int m = 0;
	int nCounts = 0;
	//ÿһ߶ڵֱߺΪԲĵԲ⣬Ϊ
	for(int i = 0;i < seg_num;i++){
		//߶˵겻ڣѰһ߶
		if(trpm->find(reader_id)->second->px[i] == -1 || trpm->find(reader_id)->second->px[i+1] == -1)
		{
			continue;
		}

		//߶ֱߺͷվreaderidantenna_idxΪԲģ뾶ΪdistԲ
		std::shared_ptr<SOLUTION> r = GetPos(trpm,reader_id,antenna_idx,dist,i);
		//ⲻڣѰһ߶
		if(r == nullptr || r->nCount <= 0){
			continue;
		}

		int k = -1;
		double c = 999999.9;
		//ڣ򱣴
		for(j = 0;j < r->nCount;j++){
			//
			xcross[j] = r->x[j];
			ycross[j] = r->y[j];
			//οվеľdistance
			double d1 = xcross[j] - trpm->find(refer_data.nReaderId)->second->x[refer_data.nAntennaIndex];
			double d2 = ycross[j] - trpm->find(refer_data.nReaderId)->second->y[refer_data.nAntennaIndex];
			double distance = sqrt(pow(d1,2) + pow(d2,2));
			d[j] = distance;
		}

		for (j = 0;j < r->nCount; j++)
		{
			if (d[j] < c)
			{
				c = d[j];
				k = j;
			}
		}

		if(c < p->pos_radius){
			p->posx = xcross[k];
			p->posy = ycross[k];
			p->pos_radius = c;
		}
	}

	return p;
}

std::shared_ptr<POS> LocateAlgorithm::TdoaLocate2d(std::shared_ptr<ReceiveDataMap> pRdm)
{
	if (pRdm->size() < 3)
	{
		return nullptr;
	}
	
	double BS[4][2] = {0};
	double h[3] = {0};

	unsigned int i = 0;
	ReceiveDataMap::iterator first = pRdm->begin();
	for (ReceiveDataMap::iterator it = pRdm->begin();it != pRdm->end();++it)
	{
		BS[i][0] = it->second->x;
		BS[i][1] = it->second->y;
		if (i > 0)
		{
			h[i-1] = CFunctions::getDistance(it->first - first->first,CFunctions::TDOA);	
		}
		i++;
		if (i > pRdm->size())
		{
			break;
		}
	}
	std::shared_ptr<POS> p = std::make_shared<POS>();

	double a  = (BS[0][0]+BS[1][0]+BS[2][0])/2;
	double c1 = 1.49445;
	double c2 = 1.49445;
	int maxgen = 1000;   
	unsigned int sizepop = 100;   
	int Vmax = 100;
	int Vmin = -100;
	int popmax = 50000;
	int popmin = -50000;

	/*ʼ*/
	/*ʼӺٶ*/
	unsigned int j = 0;
	double fitness[1][100] = {0};
	double qq1 = 0,qq2 = 0,re = 0;
	double pop[100][2] = {0},V[100][2] = {0};//sizepop = 100; 
	for(i=0;i<sizepop;i++)
	{
		for(j = 0;j<2;j++)
		{
			pop[i][j] =a* (rand()+1)/(RAND_MAX+2.0) ;
			V[i][j] = 10*(rand()+1)/(RAND_MAX+2.0);
		}
	}
	for(i = 0;i < sizepop;i++)
	{
		qq1 = pop[i][0];
		qq2 = pop[i][1];
		re = pow((sqrt((qq1-BS[1][0])*(qq1-BS[1][0])+( qq2-BS[1][1])*( qq2-BS[1][1]))-sqrt((qq1-BS[0][0])*(qq1-BS[0][0])+( qq2-BS[0][1])*( qq2-BS[0][1]))-h[0]),2)
			+pow(( sqrt((qq1-BS[2][0])*(qq1-BS[2][0])+( qq2-BS[2][1])*( qq2-BS[2][1]))-sqrt((qq1-BS[0][0])*(qq1-BS[0][0])+( qq2-BS[0][1])*( qq2-BS[0][1]))-h[1]),2);
		fitness[0][i]=re;
	}
	/*ʼӺٶ*/

	/*弫ֵȺ弫ֵ*/
	double t = 0;
	double fitnesscopy[1][100] = {0};
	for(i=0;i<sizepop;i++)
	{
		fitnesscopy[0][i] = fitness[0][i];
	}

	for(i=0;i<sizepop;i++)
	{
		for(j=i+1;j<sizepop;j++)
		{
			if (fitnesscopy[0][i]>fitnesscopy[0][j])
			{
				t = fitnesscopy[0][i];
				fitnesscopy[0][i]=fitnesscopy[0][j];
				fitnesscopy[0][j] = t;
			}
		}
	}//ȷ
	double bestfitness = fitnesscopy[0][0];
	int bestindex = 0,kk = 0;
	for(i=0;i<sizepop;i++)
	{
		if(fitness[0][i]==bestfitness)
		{
			kk = i;
		}
	}
	bestindex = kk;//ȷ
	double zbest[1][2] = {0};
	for (j = 0;j<2;j++)
	{
		zbest[0][j] = pop[bestindex][j];//ȫ
	}
	double gbest[100][2] = {0};
	for(i = 0;i<100;i++)
	{
		for (j = 0;j<2;j++)
		{
			gbest[i][j] = pop[i][j];//
		}
	}
	double fitnessgbest[1][100] = {0};
	double fitnesszbest;
	for(i = 0;i<100;i++)
	{
		fitnessgbest[0][i]=fitness[0][i];
	}

	fitnesszbest = bestfitness;
	/*弫ֵȺ弫ֵ*/
	/*Ѱ*/
	double w;
	double ws = 0.9;
	double we = 0.4;
	for(i = 0;i<maxgen;i++)
	{
		w = ws - (ws-we)*(i/maxgen)*(i/maxgen);
		for(j=0;j<sizepop;j++)
		{
			V[j][0]= w*V[j][0]+c1*(rand()+1)/(RAND_MAX+2.0)*(gbest[j][0]-pop[j][0])+c2*(rand()+1)/(RAND_MAX+2.0)*(zbest[j][0]-pop[j][0]);
			V[j][1]= w*V[j][1]+c1*(rand()+1)/(RAND_MAX+2.0)*(gbest[j][1]-pop[j][1])+c2*(rand()+1)/(RAND_MAX+2.0)*(zbest[j][1]-pop[j][1]);   
			if(V[j][0]>Vmax)
			{
				V[j][0]=Vmax;
			}
			if(V[j][1]>Vmax)
			{
				V[j][1]=Vmax;
			}
			if(V[j][0]<Vmin)
			{
				V[j][0]=Vmin;
			}
			if(V[j][1]<Vmin)
			{
				V[j][1]=Vmin;
			}
			//Ⱥ//
			pop[j][0]=pop[j][0]+ V[j][0];
			pop[j][1]= pop[j][1]+V[j][1];
			if(pop[j][0]>popmax)
			{
				pop[j][0]=popmax;
			}
			if(pop[j][1]>popmax)
			{
				pop[j][1]=popmax;
			}
			if(pop[j][0]<popmin)
			{
				pop[j][0]=popmin;
			}
			if(pop[j][1]<popmin)
			{
				pop[j][1]=popmin;
			}
			//Ⱥ//
			double qq3,qq4,re1;    
			qq3 = pop[j][0];
			qq4 = pop[j][1];
			re1=pow((sqrt((qq3-BS[1][0])*(qq3-BS[1][0])+( qq4-BS[1][1])*( qq4-BS[1][1]))-sqrt((qq3-BS[0][0])*(qq3-BS[0][0])+( qq4-BS[0][1])*( qq4-BS[0][1]))-h[0]),2)
				+pow(( sqrt((qq3-BS[2][0])*(qq3-BS[2][0])+( qq4-BS[2][1])*( qq4-BS[2][1]))-sqrt((qq3-BS[0][0])*(qq3-BS[0][0])+( qq4-BS[0][1])*( qq4-BS[0][1]))-h[1]),2);
			fitness[0][j]=re1;
		}//ȷ
		for(j=0;j<sizepop;j++)
		{
			if( fitness[0][j] < fitnessgbest[0][j])
			{
				gbest[j][0] = pop[j][0];
				gbest[j][1] = pop[j][1];
				fitnessgbest[0][j] = fitness[0][j];
			}//Ÿ

			if(fitness[0][j] < fitnesszbest)
			{
				zbest[0][0] = pop[j][0];
				zbest[0][1] = pop[j][1];
				fitnesszbest = fitness[0][j];
			}//ȺŸ
		}
	}

	p->posx = zbest[0][0];
	p->posy = zbest[0][1];

	return p;
}

std::shared_ptr<POS> LocateAlgorithm::TdoaLocate3d(std::shared_ptr<ReceiveDataMap> pRdm)
{
	if (pRdm->size() < 3)
	{
		return nullptr;
	}
	std::shared_ptr<POS> p = std::make_shared<POS>();

	double BS[4][3] = {0};
	double h[3] = {0};

	int i = 0;
	ReceiveDataMap::iterator first = pRdm->begin();
	for (ReceiveDataMap::iterator it = pRdm->begin();it != pRdm->end();++it)
	{
		BS[i][0] = it->second->x;
		BS[i][1] = it->second->y;
		BS[i][2] = it->second->z;
		if (i > 0)
		{
			h[i-1] = CFunctions::getDistance(it->first - first->first,CFunctions::TDOA);	
		}
		i++;
		if (i > pRdm->size())
		{
			break;
		}
	}

	/*ʼ*/
	double a = (BS[0][0]+BS[1][0]+BS[2][0]+BS[3][0])/2;
	double c1=1.49445;
	double c2=1.49445;
	int maxgen = 1000;   
	int sizepop = 100;   
	int Vmax = 10;
	int Vmin = -10;
	int popmax = 50;
	int popmin = -50;

	/*ʼ*/
	/*ʼӺٶ*/
	int j;
	double fitness[1][100] = {0};
	double qq1,qq2,qq5,re;
	double pop[100][3] = {0},V[100][3] = {0};//sizepop = 100; 
	//srand((unsigned)time(NULL));
	for(i=0;i<sizepop;i++)
	{
		for(j = 0;j<3;j++)
		{
			//pop[i][j] =a* (rand()+1)/(RAND_MAX+2.0) ;
			//V[i][j] = 10*(rand()+1)/(RAND_MAX+2.0);
			pop[i][j] =a* (( rand())/double(RAND_MAX));
			V[i][j] = 10* ( (rand())/double(RAND_MAX));
		}
	}//ȷ
	for(i=0;i<sizepop;i++)
	{
		qq1= pop[i][0];
		qq2= pop[i][1];
		qq5 = pop[i][2];
		re=pow(( sqrt((qq1-BS[1][0])*(qq1-BS[1][0])+( qq2-BS[1][1])*( qq2-BS[1][1])+(qq5-BS[1][2])*(qq5-BS[1][2])  )-sqrt((qq1-BS[0][0])*(qq1-BS[0][0])+( qq2-BS[0][1])*( qq2-BS[0][1])+(qq5-BS[0][2])*(qq5-BS[0][2] ))-h[0]),2)
			+pow(( sqrt((qq1-BS[2][0])*(qq1-BS[2][0])+( qq2-BS[2][1])*( qq2-BS[2][1])+(qq5-BS[2][2])*(qq5-BS[2][2])  )-sqrt((qq1-BS[0][0])*(qq1-BS[0][0])+( qq2-BS[0][1])*( qq2-BS[0][1])+ (qq5-BS[0][2])*(qq5-BS[0][2]))-h[1]),2)
			+pow(( sqrt((qq1-BS[3][0])*(qq1-BS[3][0])+( qq2-BS[3][1])*( qq2-BS[3][1])+(qq5-BS[3][2])*(qq5-BS[3][2])  )-sqrt((qq1-BS[0][0])*(qq1-BS[0][0])+( qq2-BS[0][1])*( qq2-BS[0][1])+ (qq5-BS[0][2])*(qq5-BS[0][2]))-h[2]),2);
		fitness[0][i]=re;
	}
	/*ʼӺٶ*/

	/*弫ֵȺ弫ֵ*/
	double t;double fitnesscopy[1][100] = {0};
	for(i=0;i<sizepop;i++)
	{
		fitnesscopy[0][i] = fitness[0][i];
	}

	for(i=0;i<sizepop;i++)
	{
		for(j=i+1;j<sizepop;j++)
		{
			if (fitnesscopy[0][i]>fitnesscopy[0][j])
			{
				t = fitnesscopy[0][i];
				fitnesscopy[0][i]=fitnesscopy[0][j];
				fitnesscopy[0][j] = t;
			}
		}
	}//ȷ
	double bestfitness = fitnesscopy[0][0];
	int bestindex,kk;
	for(i=0;i<sizepop;i++)
	{
		if(fitness[0][i]==bestfitness)
		{
			kk = i;
		}
	}
	bestindex = kk;//ȷ
	double zbest[1][3] = {0};
	for (j = 0;j<3;j++)
	{
		zbest[0][j] = pop[bestindex][j];//ȫ
	}
	double gbest[100][3] = {0};
	for(i = 0;i<100;i++)
	{
		for (j = 0;j<3;j++)
		{
			gbest[i][j] = pop[i][j];//
		}
	}
	double fitnessgbest[1][100] = {0};
	double fitnesszbest;
	for(i = 0;i<100;i++)
	{
		fitnessgbest[0][i]=fitness[0][i];
	}

	fitnesszbest = bestfitness;
	/*弫ֵȺ弫ֵ*/
	/*Ѱ*/
	double w;
	double ws = 0.9;
	double we = 0.4;
	//srand((unsigned)time(NULL));
	for(i = 0;i<maxgen;i++)
	{
		w = ws - (ws-we)*(i/maxgen)*(i/maxgen);
		for(j=0;j<sizepop;j++)
		{
			//V[j][0]= w*V[j][0]+c1*(rand()+1)/(RAND_MAX+2.0)*(gbest[j][0]-pop[j][0])+c2*(rand()+1)/(RAND_MAX+2.0)*(zbest[j][0]-pop[j][0]);
			//V[j][1]= w*V[j][1]+c1*(rand()+1)/(RAND_MAX+2.0)*(gbest[j][1]-pop[j][1])+c2*(rand()+1)/(RAND_MAX+2.0)*(zbest[j][1]-pop[j][1]); 
			//V[j][2]= w*V[j][2]+c1*(rand()+1)/(RAND_MAX+2.0)*(gbest[j][2]-pop[j][2])+c2*(rand()+1)/(RAND_MAX+2.0)*(zbest[j][2]-pop[j][2]); 
			V[j][0]= w*V[j][0]+c1*((rand())/double(RAND_MAX))*(gbest[j][0]-pop[j][0])+c2*((rand())/double(RAND_MAX))*(zbest[j][0]-pop[j][0]);//rand(0-1)
			V[j][1]= w*V[j][1]+c1*((rand())/double(RAND_MAX))*(gbest[j][1]-pop[j][1])+c2*((rand())/double(RAND_MAX))*(zbest[j][1]-pop[j][1]); 
			V[j][2]= w*V[j][2]+c1*((rand())/double(RAND_MAX))*(gbest[j][2]-pop[j][2])+c2*((rand())/double(RAND_MAX))*(zbest[j][2]-pop[j][2]); 

			if(V[j][0]>Vmax)
			{
				V[j][0]=Vmax;
			}
			if(V[j][1]>Vmax)
			{
				V[j][1]=Vmax;
			}
			if(V[j][2]>Vmax)
			{
				V[j][2]=Vmax;
			}
			if(V[j][0]<Vmin)
			{
				V[j][0]=Vmin;
			}
			if(V[j][1]<Vmin)
			{
				V[j][1]=Vmin;
			}
			if(V[j][2]<Vmin)
			{
				V[j][2]=Vmin;
			}

			//Ⱥ//
			pop[j][0]=pop[j][0]+ V[j][0];
			pop[j][1]= pop[j][1]+V[j][1];
			pop[j][2]= pop[j][2]+V[j][2];
			if(pop[j][0]>popmax)
			{
				pop[j][0]=popmax;
			}
			if(pop[j][1]>popmax)
			{
				pop[j][1]=popmax;
			}
			if(pop[j][2]>popmax)
			{
				pop[j][2]=popmax;
			}
			if(pop[j][0]<popmin)
			{
				pop[j][0]=popmin;
			}
			if(pop[j][1]<popmin)
			{
				pop[j][1]=popmin;
			}
			if(pop[j][2]<popmin)
			{
				pop[j][2]=popmin;
			}
			//Ⱥ//
			double qq3,qq4,qq6,re1;    
			qq3 = pop[j][0];
			qq4 = pop[j][1];
			qq6= pop[j][2];
			re1=pow((sqrt((qq3-BS[1][0])*(qq3-BS[1][0])+( qq4-BS[1][1])*( qq4-BS[1][1])+(qq6-BS[1][2])*(qq6-BS[1][2])   )-sqrt((qq3-BS[0][0])*(qq3-BS[0][0])+( qq4-BS[0][1])*( qq4-BS[0][1])+(qq6-BS[0][2])*(qq6-BS[0][2] ))-h[0]),2)
				+pow(( sqrt((qq3-BS[2][0])*(qq3-BS[2][0])+( qq4-BS[2][1])*( qq4-BS[2][1])+(qq6-BS[2][2])*(qq6-BS[2][2])  )-sqrt((qq3-BS[0][0])*(qq3-BS[0][0])+( qq4-BS[0][1])*( qq4-BS[0][1])+ (qq6-BS[0][2])*(qq6-BS[0][2]))-h[1]),2)
				+pow(( sqrt((qq3-BS[3][0])*(qq3-BS[3][0])+( qq4-BS[3][1])*( qq4-BS[3][1])+(qq6-BS[3][2])*(qq6-BS[3][2])  )-sqrt((qq3-BS[0][0])*(qq3-BS[0][0])+( qq4-BS[0][1])*( qq4-BS[0][1])+ (qq6-BS[0][2])*(qq6-BS[0][2]))-h[2]),2);
			fitness[0][j]=re1;
		}//ȷ
		for(j=0;j<sizepop;j++)
		{
			if( fitness[0][j] < fitnessgbest[0][j])
			{
				gbest[j][0] = pop[j][0];
				gbest[j][1] = pop[j][1];
				gbest[j][2] = pop[j][2];
				fitnessgbest[0][j] = fitness[0][j];
			}//Ÿ

			if(fitness[0][j] < fitnesszbest)
			{
				zbest[0][0] = pop[j][0];
				zbest[0][1] = pop[j][1];
				zbest[0][2] = pop[j][2];
				fitnesszbest = fitness[0][j];
			}//ȺŸ
		}
	}
	/*Ѱ*/

	p->posx = zbest[0][0];
	p->posy = zbest[0][1];
	p->posz = zbest[0][2];

	return p;
}

/*
 * ͨfang㷨tdoa 2άλ
 * 
 * param
 *		pRdm		վݼ
 *
 * return
 *		ضλ
 *
*/
std::shared_ptr<POS> LocateAlgorithm::tdoa_locate_2d_by_fang(std::shared_ptr<ReceiveDataMap> pRdm)
{
	if (pRdm->size() < 3)
	{
		return nullptr;
	}
	std::shared_ptr<POS> p = std::make_shared<POS>();

	//2Dλ
	std::vector<double> vtk;		//ki
	std::vector<double> vtd;		//di
	std::vector<_coordinate> vtc;	//xi,1  yi,1
	std::vector<_point> vtp;		//εĶ
	std::vector<int> vts;

	vtk.resize(0);
	vtd.resize(0);
	vtc.resize(0);
	vts.resize(0);

	_coordinate tc;

	int i = 0;
	unsigned long long time_stamp = 0;	//һεĲֵʱ
	for (ReceiveDataMap::iterator it = pRdm->begin();it != pRdm->end()&&i<3;++it)
	{
		double k =  0 ;
		k = pow(it->second->x,2) + pow(it->second->y,2) ;//+ pow(it->second->z,2)
		vtk.push_back(k);

		if (i == 0 )
		{
			time_stamp = it->second->rec_time_stamp;
			tc.x = it->second->x;
			tc.y = it->second->y;
			//tc.z = it->second->z;
		}
		long long diff_time = it->second->rec_time_stamp - time_stamp;
		double d = 0;
		d = CFunctions::getDistance(diff_time,CFunctions::TDOA);

		if (i>0)
		{
			if (d>0)
			{
				vts.push_back(1);
			} 
			else
			{
				vts.push_back(-1);
			}
		}

		vtd.push_back(d);

		_coordinate dtc;
		dtc.x = it->second->x - tc.x;
		dtc.y = it->second->y - tc.y;
		//dtc.z = it->second->z - tc.z;
		vtc.push_back(dtc);

		_point p;
		p.x = it->second->x;
		p.y = it->second->y;
		vtp.push_back(p);
		i++;
	}

	double a[4] = {0};
	double dt = 0;

	dt = vtd[1]*vtc[2].y - vtd[2]*vtc[1].y;
	if (fabs(dt) < 1E-5)
	{
		return nullptr;
	}
	a[0] = (vtd[2]*vtc[1].x - vtd[1]*vtc[2].x)/dt;
	a[1] = (-1)*((vtk[1] - vtk[0] - pow(vtd[1],2))*vtd[2] - (vtk[2] - vtk[0] - pow(vtd[2],2))*vtd[1])*0.5/dt;

	if (fabs(vtd[1]) < 1E-5)
	{
		return nullptr;
	}
	a[2] = 0.5*(vtk[1] - vtk[0] - pow(vtd[1],2) - 2*vtc[1].y*a[1])/vtd[1];
	a[3] = -1*(vtc[1].x + vtc[1].y*a[0])/vtd[1];

	double A = 0, B = 0, C = 0;
	A = pow(a[3],2) - 1 - pow(a[0],2);
	B = 2*(a[2]*a[3] + tc.x + a[0]*(tc.y - a[1]));
	C = pow(a[2],2) - pow(tc.x,2) - pow(tc.y-a[1],2);

	_point pos[MAX_READER_TDOA_PATH_NUMS];
	double delta = 0.0;
	int count = 0;

	delta = pow(B,2) - 4*A*C;
	if (delta > 0)
	{
		pos[0].x = ((-1)*B + sqrt(delta))/(2*A);
		pos[0].y = a[0]*pos[0].x + a[1];
		//TRACE(_T("x1: %.2f , y1: %.2f \r\n"),pos[0].x,pos[0].y);
		pos[1].x = ((-1)*B - sqrt(delta))/(2*A);
		pos[1].y = a[0]*pos[1].x + a[1];
		//TRACE(_T("x2: %.2f , y2: %.2f \r\n"),pos[1].x,pos[1].y);
		count  = 2;
	}else{
		return nullptr;
	}

	int idx = -1;
	int points = 0;
	for (int i=0;i<count;i++)
	{
		//if (IsInTriangle(vtp,pos[i]))
		{
			//TRACE(_T("point is in triangle. the index is : %d \r\n"),i);
			bool condition[2] = {false,false};
			double d1 = 0,d2 = 0;

			//жϣҪͬʱ
			//1.⵽1͵2ľķԺ֮ǰĲͬ
			//2.⵽1͵3ľķԺ֮ǰĲͬ
			d1 = sqrt(pow(vtp[1].x - pos[i].x,2) + pow(vtp[1].y - pos[i].y,2)) - sqrt(pow(vtp[0].x - pos[i].x,2) + pow(vtp[0].y - pos[i].y,2));
			d2 = sqrt(pow(vtp[2].x - pos[i].x,2) + pow(vtp[2].y - pos[i].y,2)) - sqrt(pow(vtp[0].x - pos[i].x,2) + pow(vtp[0].y - pos[i].y,2));

			if ((d1 < 0&&vts[0]==-1)||(d1>0&&vts[0] == 1))
			{
				condition[0] = true;
			}
			if ((d2 < 0&&vts[1]==-1)||(d2>0&&vts[1] == 1))
			{
				condition[1] =true;
			}

			if (condition[0]&&condition[1])
			{
				idx = i;
			}
		}//else{
			//TRACE(_T("point is not in triangle. the index is : %d \r\n"),i);
		//}
	}

	if (points == 2)
	{
		idx = -1;
		//TRACE(_T("There hava 2 point.\r\n"));
	}

	if (idx != -1)
	{
		//TRACE(_T("the idx is : %d \r\n"),idx);
		p->posx = pos[idx].x;
		p->posy = pos[idx].y;
	}else{
		return nullptr;
	}

	return p;
}

std::vector<std::shared_ptr<POS>> LocateAlgorithm::tdoa_locate_2d_by_fang(std::shared_ptr<ReceiveDataUnorderedMap> pRdm)
{
	std::vector<std::shared_ptr<POS>> vt_pos;
	vt_pos.resize(0);

	if (pRdm->size() < 3)
	{
		return std::move(vt_pos);
	}

	std::shared_ptr<POS> p = std::make_shared<POS>();

	//2Dλ
	std::vector<double> vtk;		//ki
	std::vector<double> vtd;		//di
	std::vector<_coordinate> vtc;	//xi,1  yi,1
	std::vector<_point> vtp;		//εĶ
	std::vector<int> vts;

	vtk.resize(0);
	vtd.resize(0);
	vtc.resize(0);
	vts.resize(0);

	_coordinate tc;

	int i = 0;
	unsigned long long time_stamp = 0;	//һεĲֵʱ
	for (auto it = pRdm->begin();it != pRdm->end()&&i<3;++it)
	{
		double k =  0 ;
		k = pow(it->second->x,2) + pow(it->second->y,2) ;//+ pow(it->second->z,2)
		vtk.push_back(k);

		if (i == 0 )
		{
			time_stamp = it->second->rec_time_stamp;
			tc.x = it->second->x;
			tc.y = it->second->y;
			//tc.z = it->second->z;
		}
		long long diff_time = it->second->rec_time_stamp - time_stamp;
		double d = 0;
		d = CFunctions::getDistance(diff_time,CFunctions::TDOA);

		if (i>0)
		{
			if (d>0)
			{
				vts.push_back(1);
			} 
			else
			{
				vts.push_back(-1);
			}
		}

		vtd.push_back(d);

		_coordinate dtc;
		dtc.x = it->second->x - tc.x;
		dtc.y = it->second->y - tc.y;
		//dtc.z = it->second->z - tc.z;
		vtc.push_back(dtc);

		_point p;
		p.x = it->second->x;
		p.y = it->second->y;
		vtp.push_back(p);
		i++;
	}

	double a[4] = {0};
	double dt = 0;

	dt = vtd[1]*vtc[2].y - vtd[2]*vtc[1].y;
	if (fabs(dt) < ZERO_PRECISION)
	{
		//return nullptr;
		return std::move(vt_pos);
	}
	a[0] = (vtd[2]*vtc[1].x - vtd[1]*vtc[2].x)/dt;
	a[1] = (-1)*((vtk[1] - vtk[0] - pow(vtd[1],2))*vtd[2] - (vtk[2] - vtk[0] - pow(vtd[2],2))*vtd[1])*0.5/dt;

	if (fabs(vtd[1]) < ZERO_PRECISION)
	{
		//return nullptr;
		return std::move(vt_pos);
	}
	a[2] = 0.5*(vtk[1] - vtk[0] - pow(vtd[1],2) - 2*vtc[1].y*a[1])/vtd[1];
	a[3] = -1*(vtc[1].x + vtc[1].y*a[0])/vtd[1];

	double A = 0, B = 0, C = 0;
	A = pow(a[3],2) - 1 - pow(a[0],2);
	B = 2*(a[2]*a[3] + tc.x + a[0]*(tc.y - a[1]));
	C = pow(a[2],2) - pow(tc.x,2) - pow(tc.y-a[1],2);

	_point pos[MAX_READER_TDOA_PATH_NUMS];
	double delta = 0.0;
	int count = 0;

	delta = pow(B,2) - 4*A*C;
	if (delta > 0)
	{
		pos[0].x = ((-1)*B + sqrt(delta))/(2*A);
		pos[0].y = a[0]*pos[0].x + a[1];
		//TRACE(_T("x1: %.2f , y1: %.2f \r\n"),pos[0].x,pos[0].y);
		pos[1].x = ((-1)*B - sqrt(delta))/(2*A);
		pos[1].y = a[0]*pos[1].x + a[1];
		//TRACE(_T("x2: %.2f , y2: %.2f \r\n"),pos[1].x,pos[1].y);
		count  = 2;
	}else{
		//return nullptr;
		return std::move(vt_pos);
	}

	for (auto i = 0;i < count;i++)
	{
		bool condition[2] = {false,false};
		double d1 = 0,d2 = 0;

		d1 = sqrt(pow(vtp[1].x - pos[i].x,2) + pow(vtp[1].y - pos[i].y,2)) - sqrt(pow(vtp[0].x - pos[i].x,2) + pow(vtp[0].y - pos[i].y,2));
		d2 = sqrt(pow(vtp[2].x - pos[i].x,2) + pow(vtp[2].y - pos[i].y,2)) - sqrt(pow(vtp[0].x - pos[i].x,2) + pow(vtp[0].y - pos[i].y,2));

		if ((d1 < 0&&vts[0]==-1)||(d1>0&&vts[0] == 1))
		{
			condition[0] = true;
		}
		if ((d2 < 0&&vts[1]==-1)||(d2>0&&vts[1] == 1))
		{
			condition[1] =true;
		}

		if (condition[0]&&condition[1])
		{
			std::shared_ptr<POS> p = std::make_shared<POS>();
			p->posx = pos[i].x;
			p->posy = pos[i].y;
			vt_pos.push_back(std::move(p));
		}
	}

	for (std::vector<std::shared_ptr<POS>>::iterator it_pos = vt_pos.begin();it_pos != vt_pos.end();)
	{
		_point p;
		p.x = (*it_pos)->posx;
		p.y = (*it_pos)->posy;
		p.z = 0;
		if (!IsInTriangle(vtp,p))
		{
			it_pos = vt_pos.erase(it_pos);
		}else{
			it_pos++;
		}
	}
	////ݽǷڲȡ
	//int idx = -1;
	//int points = 0;
	//for (int i = 0;i<count;i++)
	//{
	//	if (IsInTriangle(vtp,pos[i]))
	//	{
	//		TRACE(_T("point is in triangle. the index is : %d \r\n"),i);
	//		bool condition[2] = {false,false};
	//		double d1 = 0,d2 = 0;

	//		//жϣҪͬʱ
	//		//1.⵽1͵2ľķԺ֮ǰĲͬ
	//		//2.⵽1͵3ľķԺ֮ǰĲͬ
	//		d1 = sqrt(pow(vtp[1].x - pos[i].x,2) + pow(vtp[1].y - pos[i].y,2)) - sqrt(pow(vtp[0].x - pos[i].x,2) + pow(vtp[0].y - pos[i].y,2));
	//		d2 = sqrt(pow(vtp[2].x - pos[i].x,2) + pow(vtp[2].y - pos[i].y,2)) - sqrt(pow(vtp[0].x - pos[i].x,2) + pow(vtp[0].y - pos[i].y,2));

	//		if ((d1 < 0&&vts[0]==-1)||(d1>0&&vts[0] == 1))
	//		{
	//			condition[0] = true;
	//		}
	//		if ((d2 < 0&&vts[1]==-1)||(d2>0&&vts[1] == 1))
	//		{
	//			condition[1] =true;
	//		}

	//		if (condition[0]&&condition[1])
	//		{
	//			idx = i;
	//		}
	//	}else{
	//		TRACE(_T("point is not in triangle. the index is : %d \r\n"),i);
	//	}
	//}

	//if (points == 2)
	//{
	//	idx = -1;
	//	//TRACE(_T("There hava 2 point.\r\n"));
	//}

	//if (idx != -1)
	//{
	//	//TRACE(_T("the idx is : %d \r\n"),idx);
	//	p->posx = pos[idx].x;
	//	p->posy = pos[idx].y;
	//}else{
	//	//return nullptr;
	//	return std::move(vt_pos);
	//}

	return std::move(vt_pos);;
}

/*
 * tdoaУڸ߶Ӱ죬ȥ߶¾
 *
 * param
 *		md		ʵʲ
 *		d		վ֮ľ
 *		h		߶
 *
 * return
 *		ʵʵľ
 *
*/
double LocateAlgorithm::cal_real_distance_diff(const double& md,const double& d,const double& h,const int& s)
{
	double A = 0.0,B = 0.0,C = 0.0;

	A = 2*md;
	B = 2*d;
	C = 2*md*pow(h,2) - pow(d,2) + pow(md,2);

	double delta = 0.0;
	delta = pow(B,2) - 4*A*C;

	if (delta > 0)
	{
		/*	int sign = 0;
		double d1 = 0.0, d2 = 0.0;

		for (unsigned int i = 1;i < 3;i++)
		{
		d1 = 0.0, d2 = 0.0;
		d1 = (-1*B + pow(-1,i)*sqrt(delta))/(2*A);
		d2 = d - d1;
		if (d1 - d2 > 0)
		{
		sign = 1;
		}else{
		sign = -1;
		}

		if (sign == s)
		{
		break;
		}
		}*/
	}else if (fabs(delta) < ZERO_PRECISION)
	{
	}else{
		return INVALID_COORDINATE;
	}
	return INVALID_COORDINATE;
}

/*
 * TDOA㷨ʵ
 * LocatePos,˺PosǱ
 *		
 * param
 *		pRdm	------		ŲķվϢҪϢͬʱ
 *	    trpm    ------		ͼ
 *
 * return
 *	    ս
 *
*/
std::unique_ptr<POS> LocateAlgorithm::LocatePos(std::shared_ptr<ReceiveDataMap> pRdm,std::shared_ptr<TDOAReaderPathMap> trpm)
{
	std::unique_ptr<POS> pos(new POS);

	int nNoReaderPathIdx = 0;
	int nFirstReader[MAX_READER_TDOA_PATH_NUMS] = {-1};
	int nSecondReader[MAX_READER_TDOA_PATH_NUMS] ={-1};

	_coordinate r;
	int r_idx = 0;
	r.reason = 0;

	for (ReceiveDataMap::iterator first = pRdm->begin();first != pRdm->end();++first)
	{
		//ҵм򣬱ûд·ͼ
		TDOAReaderPathMap::iterator rdm_it = trpm->find(first->second->reader_id);
		if(rdm_it == trpm->end()){
			continue;
		}

		double ref_dist = 0.0;   //վ֮·ľ
		_coordinate res[MAX_READER_TDOA_PATH_NUMS];
		int res_idx = 0;
		for(int i = 0;i < MAX_READER_TDOA_PATH_NUMS;i++){
			res[i].x = INVALID_COORDINATE;
			res[i].y = INVALID_COORDINATE;
			res[i].z = INVALID_COORDINATE;
		}
		//洢·վid
		ReceiveData tmp_reader[MAX_READER_TDOA_PATH_NUMS];

		//洢͵һվ·ķվϢ
		ReceiveData tmp_dist_reader[MAX_READER_TDOA_PATH_NUMS];
		//͵һվڵͼķվڶֻʮ·ڣΪ34
		int nDistReaders = 0;

		//ȡһʱ
		ReceiveData f1;
		f1.antenna_id = first->second->antenna_id;
		f1.reader_id = first->second->reader_id;
		f1.rec_time_stamp = first->second->rec_time_stamp;
		f1.x = first->second->x;
		f1.y = first->second->y;
		f1.z = first->second->z;

		ReceiveDataMap::iterator second = first;
		std::advance(second,1);
		//ӵڶʼ
		for(;second != pRdm->end();++second){
			//ȡڶʱ
			ReceiveData f2;
			f2.antenna_id = second->second->antenna_id;
			f2.reader_id = second->second->reader_id;
			f2.rec_time_stamp = second->second->rec_time_stamp;
			f2.x = second->second->x;
			f2.y = second->second->y;
			f2.z = second->second->z;

			//ʱ쳣
			if(f1.rec_time_stamp == LLONG_MAX || f2.rec_time_stamp == LLONG_MAX){
				continue;
			}

			if(f1.reader_id == f2.reader_id){
				continue;
			}

			ReaderPathMap::iterator rpm_it = trpm->find(f1.reader_id)->second->find(f2.reader_id);
			if(rpm_it == trpm->find(f1.reader_id)->second->end()){
				continue;
			}

			//ݾжϼλȡʱʹ
			int nSign = 1;
			long long diffTime = f1.rec_time_stamp - f2.rec_time_stamp;

			//λ
			double dist = CFunctions::getDistance(diffTime,CFunctions::TDOA);

			double readers_dist = sqrt(pow(f1.x - f2.x,2) + pow(f1.y - f2.y,2));

			if(fabs(dist) - readers_dist > 0){
				continue;
			}

			//͵һվڵͼ
			tmp_dist_reader[nDistReaders].reader_id = f2.reader_id;
			tmp_dist_reader[nDistReaders].x = f2.x;
			tmp_dist_reader[nDistReaders].y = f2.y;
			tmp_dist_reader[nDistReaders].z = f2.z;
			tmp_dist_reader[nDistReaders].rec_time_stamp = f2.rec_time_stamp;
			nDistReaders++;

			std::shared_ptr<ReaderPath> pRP = trpm->find(f1.reader_id)->second->find(f2.reader_id)->second;

			tmp_reader[nNoReaderPathIdx].reader_id = f2.reader_id;
			tmp_reader[nNoReaderPathIdx].x = f2.x;
			tmp_reader[nNoReaderPathIdx].y = f2.y;
			tmp_reader[nNoReaderPathIdx].z = f2.z;
			tmp_reader[nNoReaderPathIdx].rec_time_stamp = f2.rec_time_stamp;
			nNoReaderPathIdx++;

			//վ֮߶θ
			int seg_num = pRP->nRealCalcPoints - 1;

			if(seg_num == 0 || seg_num > 100){
				continue;
			}

			//Ϊ˫վ֮i߶λߵj߶ηֱ
			//߷վ֮һֱߣ
			double xcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
			double ycross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
			double zcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};

			int nIdx = 0;

			//߶θʼ
			for(int i = 0;i < seg_num;i++){
				//λ꣬˫ߺ߶ཻĽ
				std::shared_ptr<SOLUTION> r = LocateAlgorithm::GetPos(pRP,dist,i);

				//޽Ч
				if(r == nullptr ){
					continue;
				}
				if(r->nCount == 0){
					continue;
				}

				if(r->nCount == 1){
					xcross[nIdx] = r->x[0];
					ycross[nIdx] = r->y[0];

					res[res_idx].x = xcross[nIdx];
					res[res_idx].y = ycross[nIdx];
					res[res_idx].z = zcross[nIdx];

					nIdx++;
					res_idx++;
				}

				if(r->nCount == 2){
					for(int j = 0; j < 2;j++){
						xcross[j] = r->x[j];
						ycross[j] = r->y[j];
						nIdx++;
					}
				}

				if(nIdx == 2){
					//⵽֮ľ
					double deltad[2] = {0};
					for(int j = 0; j < 2;j ++){
						double d[2] = {0};
						double dx1 = xcross[j] - pRP->x[0];
						double dy1 = ycross[j] - pRP->y[0];
						d[0] = sqrt(pow(dx1,2) + pow(dy1,2));

						double dx2 = xcross[j] - pRP->x[1];
						double dy2 = ycross[j] - pRP->y[1];
						d[1] = sqrt(pow(dx2,2) + pow(dy2,2));

						deltad[j] = d[0] - d[1];
					}

					int idx = 0;	

					//Ӧú֮ǰdistͬ
					if(dist > 0){
						for(int j = 0;j < 2;j++){
							if(deltad[j] > 0){
								idx = j;
								break;
							}
						}	
					}else{
						for(int j = 0;j < 2;j++){
							if(deltad[j] < 0){
								idx = j;
								break;
							}
						}	
					}
					nFirstReader[res_idx]  = f1.reader_id;
					nSecondReader[res_idx] = f2.reader_id;

					res[res_idx].x = xcross[idx];
					res[res_idx].y = ycross[idx];
					res[res_idx].z = zcross[idx];
					res_idx++;
				}		
				continue;
			}
		}

		if(res_idx == 1){
			bool bValid = true;

			//λڷվҪжϴ˷վǷΪspecialΪspecialܴ˶λ
			for(ReceiveDataMap::iterator it = pRdm->begin();it!=pRdm->end();++it){
				double dist = sqrt(pow(res[0].x - it->second->x,2) + pow(res[0].y - it->second->y,2));	
				if(dist<4){
					if(it->second->special == 0){
						r.reason = ALGO_FAILED_CONDITION_12;
						ALGORITHM_FAILED(ALGO_FAILED_CONDITION_12);
						bValid = false;
					}
				}
			}

			if(pRdm->size()>=3&&bValid){
				double dist[2] = {0};
				//ѡȡվʽ:
				//ѡȡ͵һվеͼվб
				//磺վ˳21,3У1,2ͣ2,3֮еͼôѡȡ1,3б
				//վ˳1,23У12еͼ(1,3)֮޵ͼôʱͲʹ·б
				if(nDistReaders == 2){
					dist[0] = sqrt(pow(res[0].x - tmp_dist_reader[0].x,2) + pow(res[0].y - tmp_dist_reader[0].y,2));
					dist[1] = sqrt(pow(res[0].x - tmp_dist_reader[1].x,2) + pow(res[0].y - tmp_dist_reader[1].y,2));

					double dif1 = fabs(dist[0] - dist[1]);

					long long dt = tmp_dist_reader[0].rec_time_stamp - tmp_dist_reader[1].rec_time_stamp;
					double dif2 = fabs(CFunctions::getDistance(dt,CFunctions::TDOA));

					double dif = fabs(dif1 - dif2);

					if(dif>10){
						r.reason = ALGO_FAILED_CONDITION_13;
						ALGORITHM_FAILED(ALGO_FAILED_CONDITION_13);
						bValid = false;
					}	
				}
			}

			if(bValid){
				r.x = res[0].x;
				r.y = res[0].y;
				r.z = res[0].z;
				for (int i=0;i<MAX_READER_TDOA_PATH_NUMS;i++)
				{
					pos->dDiff[i] = 0;
				}
			}
		}else if(res_idx >= 2){
			double d = 99999.9;

			long long dt = tmp_reader[0].rec_time_stamp - tmp_reader[1].rec_time_stamp;
			//λ
			double ref_dist = abs(CFunctions::getDistance(dt,CFunctions::TDOA));

			for(int i = 0;i<res_idx;i++){
				double d_tmp = abs(sqrt(pow(res[i].x - tmp_reader[0].x,2) + pow(res[i].y - tmp_reader[0].y,2)) - sqrt(pow(res[i].x - tmp_reader[1].x,2) + pow(res[i].y - tmp_reader[1].y,2)));
				double d_diff = abs(d_tmp - ref_dist);
				pos->dDiff[i] = d_diff;
				if(d_diff < d){
					d = d_diff;
					r_idx = i;
				}
			}

			if(pRdm->size()>=3){
				if(pos->dDiff[r_idx] < 4){
					r.x = res[r_idx].x;
					r.y = res[r_idx].y;
					r.z = res[r_idx].z;
				}else{
					r.reason = ALGO_FAILED_CONDITION_14;
					ALGORITHM_FAILED(ALGO_FAILED_CONDITION_14);
				}
			}
		}else{
			//ĸ<=0
			continue;
		}

		//ʾҵˣݶ
		if (r.x != INVALID_COORDINATE && r.y != INVALID_COORDINATE)
		{
			break;
		}
	}
	//յõĽ
	pos->posx = r.x;
	pos->posy = r.y;
	pos->posz = 0;
	pos->reason = r.reason;

	if(pos->posx != INVALID_COORDINATE && pos->posy != INVALID_COORDINATE){
		pos->nFirstReader = nFirstReader[r_idx];
		pos->nSecondReader = nSecondReader[r_idx];
	}

	return pos;
}

SOLUTION* LocateAlgorithm::GetPos(ReaderPathMap rpm,int sta_num,int ant,double dist,int i)
{
	double x1 = 0.0;
	double y1 = 0.0;
	double x2 = 0.0;
	double y2 = 0.0;

	double deta = 0.0;  //b^2 - 4*a*c;
	int count = 0;	//̽ĸ

	if((rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->px[i+1]) == 0){
		//һĽ
		x1 = rpm.find(sta_num)->second->px[i];
		y1 = rpm.find(sta_num)->second->y[ant] - dist;
		x2 = rpm.find(sta_num)->second->px[i];
		y2 = dist + rpm.find(sta_num)->second->y[ant];
		count = 2;
	}else{
		//б
		double k = (rpm.find(sta_num)->second->py[i] - rpm.find(sta_num)->second->py[i+1])/(rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->px[i+1]);

		//̶
		//ȷ
		//ԲΪs[sta_num].x[ant],s[sta_num].y[ant];
		double a = pow(k,2) + 1;
		double b = 2*(k*(rpm.find(sta_num)->second->py[i] - k*rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->y[ant])- rpm.find(sta_num)->second->x[ant]);
		double d = rpm.find(sta_num)->second->py[i] - k * rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->y[ant]; 
		double c = pow(rpm.find(sta_num)->second->x[ant],2) + pow(d,2) - pow(dist,2);

		//deta = b^2 - 4*a*c жϷǷн
		deta = pow(b,2) - 4*a*c; //
		if(deta>0){
			count = 2;
		}else if(deta == 0){
			count = 1;
		}
		else{
			count = 0;
		}

		if(count == 0){
			return NULL;
		}

		//
		x1 = -(b + sqrt(deta))/(2*a);
		x2 = (-b + sqrt(deta) )/(2*a);
		y1 = k*x1 + rpm.find(sta_num)->second->py[i] - k*rpm.find(sta_num)->second->px[i];
		y2 = k*x2 + rpm.find(sta_num)->second->py[i] - k*rpm.find(sta_num)->second->px[i];
	}

	double x[3] = {0,0,0};
	double y[3] = {0,0,0};
	
	x[0] = x1;
	x[1] = x2;
	y[0] = y1;
	y[1] = y2;

	if(count>0){
		for(int t = 0;t<count;t++){
			if(x[t] < min(rpm.find(sta_num)->second->px[i],rpm.find(sta_num)->second->px[i+1]) - 0.01
				||x[t] > max(rpm.find(sta_num)->second->px[i],rpm.find(sta_num)->second->px[i+1]) + 0.01
				||y[t] < min(rpm.find(sta_num)->second->py[i],rpm.find(sta_num)->second->py[i+1])
				||y[t] > max(rpm.find(sta_num)->second->py[i],rpm.find(sta_num)->second->py[i+1])){
				x[t] = 0;
				y[t] = 0;
			}
		}
	}

	SOLUTION* result = new SOLUTION;
	memset(result->x,0,3*sizeof(double));
	memset(result->y,0,3*sizeof(double));
	memset(result->z,0,3*sizeof(double));
	result->x[0] = x[0];
	result->x[1] = x[1];
	result->y[0] = y[0];
	result->y[1] = y[1];
	result->z[0] = 0;
	result->z[1] = 0;

	return result;
}

/*
 *
 * param
 *		trpm
 *		sta_num
 *		ant
 *		dist
 *		i
 *
 * return
 *
*/
std::shared_ptr<SOLUTION> LocateAlgorithm::GetPos(std::shared_ptr<TOFReaderPathMap> trpm,int reader_id,int antenna_idx,double dist,int seg_idx)
{
	std::shared_ptr<SOLUTION> s = std::make_shared<SOLUTION>();

	double x1 = 0.0;
	double y1 = 0.0;
	double x2 = 0.0;
	double y2 = 0.0;

	double deta = 0.0;  //b^2 - 4*a*c;
	int count = 0;	//̽ĸ

	if(abs(trpm->find(reader_id)->second->px[seg_idx] - trpm->find(reader_id)->second->px[seg_idx + 1]) < ZERO_PRECISION){
		//һĽ
		x1 = trpm->find(reader_id)->second->px[seg_idx];
		y1 = trpm->find(reader_id)->second->y[antenna_idx] - dist;
		x2 = trpm->find(reader_id)->second->px[seg_idx];
		y2 = dist + trpm->find(reader_id)->second->y[antenna_idx];
		count = 2;
	}/*else if(abs(trpm->find(sta_num)->second->py[i] - trpm->find(sta_num)->second->py[i+1]) < ZERO_PRECISION){
		y1 = y2 = trpm->find(sta_num)->second->py[i];
		x1 = trpm->find(sta_num)->second->y[ant] - dist;
		x2 = trpm->find(sta_num)->second->y[ant] + dist;
		count = 2;
	}*/else{
		//б
		double k = (trpm->find(reader_id)->second->py[seg_idx] - trpm->find(reader_id)->second->py[seg_idx + 1])/(trpm->find(reader_id)->second->px[seg_idx] - trpm->find(reader_id)->second->px[seg_idx + 1]);
		//double k = (trpm->find(reader_id)->second->y[seg_idx] - trpm->find(reader_id)->second->y[seg_idx + 1])/(trpm->find(reader_id)->second->x[seg_idx] - trpm->find(reader_id)->second->x[seg_idx + 1]);
		//3.4286
		//double b = trpm->find(reader_id)->second->y[antenna_idx] - k*trpm->find(reader_id)->second->x[antenna_idx];
		double b = trpm->find(reader_id)->second->py[seg_idx] - k*trpm->find(reader_id)->second->px[seg_idx];
		double A = pow(k,2) + 1;
		double B = 2*k*(b - trpm->find(reader_id)->second->y[antenna_idx]) - 2*trpm->find(reader_id)->second->x[antenna_idx];
		double C = pow(trpm->find(reader_id)->second->x[antenna_idx],2) + pow(b - trpm->find(reader_id)->second->y[antenna_idx],2) - pow(dist,2);
		
		deta = pow(B,2) - 4*A*C;
		//̶
		//ȷ
		//ԲΪs[sta_num].x[ant],s[sta_num].y[ant];
		//double a = pow(k,2) + 1;
		//double b = 2*(k*(trpm->find(sta_num)->second->py[i] - k*trpm->find(sta_num)->second->px[i] - trpm->find(sta_num)->second->y[ant])- trpm->find(sta_num)->second->x[ant]);
		//double d = trpm->find(sta_num)->second->py[i] - k * trpm->find(sta_num)->second->px[i] - trpm->find(sta_num)->second->y[ant]; 
		////double b = 2*k*d - 2*trpm->find(sta_num)->second->px[i];
		//double c = pow(trpm->find(sta_num)->second->x[ant],2) + pow(d,2) - pow(dist,2);

		////deta = b^2 - 4*a*c жϷǷн
		//deta = pow(b,2) - 4*a*c; //
		if(deta>0){
			count = 2;
		}else if(deta == 0){
			count = 1;
		}
		else{
			count = 0;
		}

		if(count == 0){
			return NULL;
		}

		//
		x1 = -(B + sqrt(deta))/(2*A);
		x2 = (-B + sqrt(deta) )/(2*A);
		//x1 = -(b + sqrt(deta))/(2*a);
		//x2 = (-b + sqrt(deta) )/(2*a);
		y1 = k*x1 + trpm->find(reader_id)->second->py[seg_idx] - k*trpm->find(reader_id)->second->px[seg_idx];
		y2 = k*x2 + trpm->find(reader_id)->second->py[seg_idx] - k*trpm->find(reader_id)->second->px[seg_idx];
	}

	double x[3] = {0,0,0};
	double y[3] = {0,0,0};

	x[0] = x1;
	x[1] = x2;
	y[0] = y1;
	y[1] = y2;

	int nValidCount = count;
	if(count > 0){
		for(int t = 0;t < count;t++){
			if(x[t] < min(trpm->find(reader_id)->second->px[seg_idx],trpm->find(reader_id)->second->px[seg_idx+1])
				||x[t] > max(trpm->find(reader_id)->second->px[seg_idx],trpm->find(reader_id)->second->px[seg_idx+1])
				||y[t] < min(trpm->find(reader_id)->second->py[seg_idx],trpm->find(reader_id)->second->py[seg_idx+1])
				||y[t] > max(trpm->find(reader_id)->second->py[seg_idx],trpm->find(reader_id)->second->py[seg_idx+1])){
					x[t] = INVALID_COORDINATE;
					y[t] = INVALID_COORDINATE;
					nValidCount--;
			}
		}
	}

	s->nCount = nValidCount;
	switch (s->nCount)
	{
	case 1:
		for (int i = 0;i < count;i++)
		{
			if (x[i] != INVALID_COORDINATE && y[i] != INVALID_COORDINATE)
			{
				s->x[0] = x[i];
				s->y[0] = y[i];
				break;
			}
		}
		break;
	case 2:
		for (int i = 0;i < s->nCount;i++)
		{
			s->x[i] = x[i];
			s->y[i] = y[i];
		}
		break;
	default:
		break;
	}

	return s;
}

/*
 * Tofάλʵ
 * С˷ԶŽ
 *
 * param
 *		pRdtm		λ
 *
 * return
 *		λ
*/
std::shared_ptr<algorithm::POS> LocateAlgorithm::tof_locate_2d(std::shared_ptr<ReceiveDataTofVector>& pRdtv)
{
	std::shared_ptr<algorithm::POS> sp_pos = std::make_shared<algorithm::POS>();

	//һţٵ
	//Eigen::VectorXd x(2);
	//Eigen::MatrixXd data(3,3);

	//int i = 0;
	//for (auto it = pRdtv->begin();it != pRdtv->end();++it,++i)
	//{
	//	data(i,0) = (*it)->x;
	//	data(i,1) = (*it)->y;
	//	//data(i,2) = (*it)->z;

	//	data(i,2) = (*it)->distance;
	//}

	//TofFunctor functor(data);
	//Eigen::NumericalDiff<TofFunctor> numDiff(functor);
	//Eigen::LevenbergMarquardt<Eigen::NumericalDiff<TofFunctor>,double> lm(numDiff);
	//lm.parameters.maxfev = 2000;
	//lm.parameters.xtol = 1.0e-10;

	//// 򷵻ظý
	//int ret = lm.minimize(x);

	////x=-5.56 y=1.06 ʵλ(-5.55,1.151)
	////ƫݵĲλã(-5.399,1.288)
	//if(ret > 0) 
	//{
	//	double a = x[0];
	//	double b = x[1];
	//	double c = x[2];
	//	//double d = x[3];

	//	sp_pos->posx = x[0];
	//	sp_pos->posy = x[1];
	//	//sp_pos->posz = x[2];
	//}

	//˷Խֳݵ
	Eigen::MatrixXf A(3,4);
	Eigen::VectorXf B(3,1);
	Eigen::MatrixXf X;

	int i = 0;
	for (auto it = pRdtv->begin();it != pRdtv->end();++it,++i)
	{
		A(i,0) = A(i,1) = 1;
		A(i,2) = -2*(*it)->x;
		A(i,3) = -2*(*it)->y;

		B(i,0) = pow((*it)->distance,2) - pow((*it)->x,2) - pow((*it)->y,2);
	}

	X = A.jacobiSvd(Eigen::ComputeThinU | Eigen::ComputeThinV).solve(B);

	double a = X(0);
	double b = X(1);
	double c = X(2);
	double d = X(3);

	//x=-5.56 y=1.06 ʵλ(-5.55,1.151)
	//ƫݵĲλã(-5.399,1.288)
	sp_pos->posx = X(2);	
	sp_pos->posy = X(3);

	return std::move(sp_pos);
}

std::vector<op::point> LocateAlgorithm::calc_pos(const op::point& circle_center, const double& radius, const op::point* pLine)
{
	vector<op::point> ret;

	double r = radius;
	op::point p1, p2;
	if (abs(circle_center.x - pLine[0].x) < 1E-4&&abs(circle_center.x - pLine[1].x) < 1E-4) {
		p1.x = pLine[0].x;
		p1.y = circle_center.y + r;

		p2.x = pLine[0].x;
		p2.y = circle_center.y - r;
	}
	else {
		double k = (pLine[1].y - pLine[0].y) / (pLine[1].x - pLine[0].x);
		double b = pLine[1].y - k * pLine[1].x;
		double A = pow(k, 2) + 1;
		double B = 2 * k*(b - circle_center.y) - 2 * circle_center.x;
		double C = pow(circle_center.x, 2) + pow(b - circle_center.y, 2) - pow(r, 2);
		double dt = pow(B, 2) - 4 * A*C;

		if (dt <= 0) {
			return ret;
		}

		//
		p1.x = -(B + sqrt(dt)) / (2 * A);
		p2.x = (-B + sqrt(dt)) / (2 * A);
		p1.y = k * p1.x + b;
		p2.y = k * p2.x + b;
	}
	ret.push_back(p1);
	ret.push_back(p2);

	return ret;
}

/*
 * TDOA㷨ʵ
 * Pos
 *		
 * param
 *		pRdm	------		ŲķվϢҪϢͬʱ
 *	    trpm    ------		ͼ
 *
 * return
 *	    ս
 *
*/
std::shared_ptr<POS> LocateAlgorithm::Pos(std::shared_ptr<ReceiveDataMap> pRdm,std::shared_ptr<TDOAReaderPathMap> trpm)
{
	std::shared_ptr<POS> pos = std::make_shared<POS>();
	double a = 0;
	double ref_dist = 0.0;   //վ֮·ľ
	
	_coordinate res[MAX_READER_TDOA_PATH_NUMS];
	int res_idx = 0;
	for(int i = 0;i < MAX_READER_TDOA_PATH_NUMS;i++){
		res[i].x = INVALID_COORDINATE;
		res[i].y = INVALID_COORDINATE;
		res[i].z = INVALID_COORDINATE;
	}

	bool bFirst = true;
	int nNoReaderPathIdx = 0;
	int nFirstReader[MAX_READER_TDOA_PATH_NUMS] = {-1};
	int nSecondReader[MAX_READER_TDOA_PATH_NUMS] ={-1};

	//洢·վid
	ReceiveData tmp_reader[MAX_READER_TDOA_PATH_NUMS];

	//洢͵һվ·ķվϢ
	ReceiveData tmp_dist_reader[MAX_READER_TDOA_PATH_NUMS];
	int nDistReaders = 0;

	ReceiveDataMap::iterator first = pRdm->begin();
	ReceiveDataMap::iterator second = first;
	//ƫƵڶԪ
	std::advance(second,1);

	//ȡһʱ
	ReceiveData f1;
	f1.antenna_id = first->second->antenna_id;
	f1.reader_id = first->second->reader_id;
	f1.rec_time_stamp = first->second->rec_time_stamp;
	f1.x = first->second->x;
	f1.y = first->second->y;
	f1.z = first->second->z;

	//ӵڶʼ
	for(;second != pRdm->end();++second){
		//ȡڶʱ
		ReceiveData f2;
		f2.antenna_id = second->second->antenna_id;
		f2.reader_id = second->second->reader_id;
		f2.rec_time_stamp = second->second->rec_time_stamp;
		f2.x = second->second->x;
		f2.y = second->second->y;
		f2.z = second->second->z;

		//ʱ쳣
		if(f1.rec_time_stamp == LLONG_MAX || f2.rec_time_stamp == LLONG_MAX){
			continue;
		}

		if(f1.reader_id == f2.reader_id){
			continue;
		}

		//ҵм򣬱ûд·ͼ
		TDOAReaderPathMap::iterator rdm_it = trpm->find(f1.reader_id);
		if(rdm_it == trpm->end()){
			continue;
		}

		ReaderPathMap::iterator rpm_it = trpm->find(f1.reader_id)->second->find(f2.reader_id);
		if(rpm_it == trpm->find(f1.reader_id)->second->end()){
			continue;
		}else{
			//͵һվڵͼ
			tmp_dist_reader[nDistReaders].reader_id = f2.reader_id;
			tmp_dist_reader[nDistReaders].x = f2.x;
			tmp_dist_reader[nDistReaders].y = f2.y;
			tmp_dist_reader[nDistReaders].z = f2.z;
			tmp_dist_reader[nDistReaders].rec_time_stamp = f2.rec_time_stamp;
			nDistReaders++;
		}

		//ݾжϼλȡʱʹ
		int nSign = 1;
		long long diffTime = f1.rec_time_stamp - f2.rec_time_stamp;

		//λ
		double dist = CFunctions::getDistance(diffTime,CFunctions::TDOA);

		double readers_dist = sqrt(pow(f1.x - f2.x,2) + pow(f1.y - f2.y,2));

		if(fabs(dist) - readers_dist > 0){
			continue;
		}

		std::shared_ptr<ReaderPath> pRP = trpm->find(f1.reader_id)->second->find(f2.reader_id)->second;

		//͵һվڵͼ
		tmp_reader[nNoReaderPathIdx].reader_id = f2.reader_id;
		tmp_reader[nNoReaderPathIdx].x = f2.x;
		tmp_reader[nNoReaderPathIdx].y = f2.y;
		tmp_reader[nNoReaderPathIdx].z = f2.z;
		tmp_reader[nNoReaderPathIdx].rec_time_stamp = f2.rec_time_stamp;
		nNoReaderPathIdx++;

		//վ֮߶θ
		int seg_num = pRP->nRealCalcPoints - 1;

		if(seg_num == 0 || seg_num > 100){
			continue;
		}

		//Ϊ˫վ֮i߶λߵj߶ηֱ
		//߷վ֮һֱߣ
		double xcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
		double ycross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
		double zcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};

		int nIdx = 0;

		//߶θʼ
		for(int i = 0;i < seg_num;i++){
			//λ꣬˫ߺ߶ཻĽ
			std::shared_ptr<SOLUTION> r = LocateAlgorithm::GetPos(pRP,dist,i);

			//޽Ч
			if(r == nullptr ||r->nCount == 0){
				continue;
			}

			if(r->nCount == 1){
				xcross[nIdx] = r->x[0];
				ycross[nIdx] = r->y[0];

				res[res_idx].x = xcross[nIdx];
				res[res_idx].y = ycross[nIdx];
				res[res_idx].z = zcross[nIdx];

				nIdx++;
				res_idx++;
			}

			if(r->nCount == 2){
				for(int j = 0; j < 2;j++){
					xcross[j] = r->x[j];
					ycross[j] = r->y[j];
					nIdx++;
				}
			}

			if(nIdx == 2){
				//⵽֮ľ
				double deltad[2] = {0};
				for(int j = 0; j < 2;j ++){
					double d[2] = {0};
					double dx1 = xcross[j] - pRP->x[0];
					double dy1 = ycross[j] - pRP->y[0];
					d[0] = sqrt(pow(dx1,2) + pow(dy1,2));

					double dx2 = xcross[j] - pRP->x[1];
					double dy2 = ycross[j] - pRP->y[1];
					d[1] = sqrt(pow(dx2,2) + pow(dy2,2));

					deltad[j] = d[0] - d[1];
				}

				int idx = 0;	

				//Ӧú֮ǰdistͬ
				if(dist > 0){
					for(int j = 0;j < 2;j++){
						if(deltad[j] > 0){
							idx = j;
							break;
						}
					}	
				}else{
					for(int j = 0;j < 2;j++){
						if(deltad[j] < 0){
							idx = j;
							break;
						}
					}	
				}
				nFirstReader[res_idx]  = f1.reader_id;
				nSecondReader[res_idx] = f2.reader_id;

				res[res_idx].x = xcross[idx];
				res[res_idx].y = ycross[idx];
				res[res_idx].z = zcross[idx];
				res_idx++;
			}		
			continue;
		}
	}

	_coordinate r;
	r.x = INVALID_COORDINATE;
	r.y = INVALID_COORDINATE;
	r.z = INVALID_COORDINATE;

	if(res_idx == 1){
		bool bValid = true;

		//λڷվҪжϴ˷վǷΪspecialΪspecialܴ˶λ
		for(ReceiveDataMap::iterator it = pRdm->begin();it!=pRdm->end();++it){
			double dist = sqrt(pow(res[0].x - it->second->x,2) + pow(res[0].y - it->second->y,2));	
			if(dist<NEAR_READER){
				if(it->second->special == 0){
					r.reason = ALGO_FAILED_CONDITION_12;
					ALGORITHM_FAILED(ALGO_FAILED_CONDITION_12);
					bValid = false;
				}
			}
		}

		if(pRdm->size()>=3&&bValid){
			double dist[2] = {0};
			//ѡȡվʽ:
			//ѡȡ͵һվеͼվб
			//磺վ˳21,3У1,2ͣ2,3֮еͼôѡȡ1,3б
			//վ˳1,23У12еͼ(1,3)֮޵ͼôʱͲʹ·б
			if(nDistReaders == 2){
				//ڶվվ޵ͼ򲻸ʹ߼
				dist[0] = sqrt(pow(res[0].x - tmp_dist_reader[0].x,2) + pow(res[0].y - tmp_dist_reader[0].y,2));
				dist[1] = sqrt(pow(res[0].x - tmp_dist_reader[1].x,2) + pow(res[0].y - tmp_dist_reader[1].y,2));

				double dif1 = fabs(dist[0] - dist[1]);
				long long dt = tmp_dist_reader[0].rec_time_stamp - tmp_dist_reader[1].rec_time_stamp;
				double dif2 = fabs(CFunctions::getDistance(dt,CFunctions::TDOA));
				double dif = fabs(dif1 - dif2);
				if(dif>MIN_DIFFER_DISTANCE){
					r.reason = ALGO_FAILED_CONDITION_13;
					ALGORITHM_FAILED(ALGO_FAILED_CONDITION_13);
					bValid = false;
				}	
			}
		}

		if(bValid){
			r.x = res[0].x;
			r.y = res[0].y;
			r.z = res[0].z;
			for (int i=0;i<MAX_READER_TDOA_PATH_NUMS;i++)
			{
				pos->dDiff[i] = 0;
			}
		}
	}

	int r_idx = 0;

	if(res_idx >= 2){
		double d = 99999.9;
		
		long long dt = tmp_reader[0].rec_time_stamp - tmp_reader[1].rec_time_stamp;
		//λ
		double ref_dist = abs(CFunctions::getDistance(dt,CFunctions::TDOA));

		for(int i = 0;i<res_idx;i++){
			double d_tmp = abs(sqrt(pow(res[i].x - tmp_reader[0].x,2) + pow(res[i].y - tmp_reader[0].y,2)) - sqrt(pow(res[i].x - tmp_reader[1].x,2) + pow(res[i].y - tmp_reader[1].y,2)));
			double d_diff = abs(d_tmp - ref_dist);
			pos->dDiff[i] = d_diff;
			if(d_diff < d){
				d = d_diff;
				r_idx = i;
			}
		}

		if(pRdm->size() >= 3){
			if(pos->dDiff[r_idx] < NEAR_READER){
				r.x = res[r_idx].x;
				r.y = res[r_idx].y;
				r.z = res[r_idx].z;
			}else{
				r.reason = ALGO_FAILED_CONDITION_14;
				ALGORITHM_FAILED(ALGO_FAILED_CONDITION_14);
			}
		}
	}

	//յõĽ
	pos->posx = r.x;
	pos->posy = r.y;
	pos->posz = 0;
	pos->reason = r.reason;

	if(pos->posx != INVALID_COORDINATE && pos->posy != INVALID_COORDINATE){
		pos->nFirstReader = nFirstReader[r_idx];
		pos->nSecondReader = nSecondReader[r_idx];
	}

	return pos;
}

std::shared_ptr<POS> LocateAlgorithm::Pos(std::shared_ptr<POS> pos,std::shared_ptr<TDOAReaderPathMap> trpm)
{
	if(trpm->find(pos->nFirstReader) == trpm->end()){
		return nullptr;
	}
	if(trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader)==trpm->find(pos->nFirstReader)->second->end()){
		return nullptr;
	}

	std::shared_ptr<POS> p = std::make_shared<POS>();

	_coordinate res[2];
	int res_idx = 0;
	for(int i = 0;i < 2;i++){
		res[i].x = INVALID_COORDINATE;
		res[i].y = INVALID_COORDINATE;
		res[i].z = INVALID_COORDINATE;
	}

	//õͼ
	std::shared_ptr<ReaderPath> pRP = trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader)->second;
	//
	double distance = 0.0;
	distance = sqrt(pow(pos->posx - pRP->x[0],2 ) + pow(pos->posy - pRP->y[0],2 )) - 
		sqrt(pow(pos->posx - pRP->x[1],2 ) + pow(pos->posy - pRP->y[1],2 ));

	//վ֮߶θ
	int seg_num = pRP->nRealCalcPoints - 1;

	if(seg_num == 0){
		return nullptr;
	}

	double xcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
	double ycross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
	double zcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};

	int nIdx = 0;
	int nResIdx = 0;

	for(int i = 0;i < seg_num;i++){
		//λ꣬˫ߺ߶ཻĽ
		std::shared_ptr<SOLUTION> r = GetPos(pRP,distance,i);

		//޽Ч
		if(r == nullptr){
			continue;
		}
		if(r->nCount == 0){
			continue;
		}

		if(r->nCount == 1){
			xcross[nIdx] = r->x[0];
			ycross[nIdx] = r->y[0];
			nIdx++;
		}
		if(r->nCount == 2){
			for(int j = 0; j < 2;j++){
				xcross[j] = r->x[j];
				ycross[j] = r->y[j];
				nIdx++;
			}
		}

		if(nIdx == 2){
			//⵽֮ľ
			double deltad[2] = {0};
			for(int j = 0; j < 2;j ++){
				double d[2] = {0};
				double dx1 = xcross[j] - pRP->x[0];
				double dy1 = ycross[j] - pRP->y[0];
				d[0] = sqrt(pow(dx1,2) + pow(dy1,2));

				double dx2 = xcross[j] - pRP->x[1];
				double dy2 = ycross[j] - pRP->y[1];
				d[1] = sqrt(pow(dx2,2) + pow(dy2,2));

				deltad[j] = d[0] - d[1];
			}

			int idx = 0;	
			//Ӧú֮ǰdistͬ
			if(distance > 0){
				for(int j = 0;j < 2;j++){
					if(deltad[j] > 0){
						idx = j;
						break;
					}
				}	
			}else{
				for(int j = 0;j < 2;j++){
					if(deltad[j] < 0){
						idx = j;
						break;
					}
				}	
			}
			res[nResIdx].x = xcross[idx];
			res[nResIdx].y = ycross[idx];
			res[nResIdx].z = zcross[idx];
		}		
		continue;
	}

	if (res[nResIdx].x == INVALID_COORDINATE && res[nResIdx].y == INVALID_COORDINATE)
	{
		return nullptr;
	}

	p->posx = res[nResIdx].x;
	p->posy = res[nResIdx].y;
	p->posz = res[nResIdx].z;

	return p;
}

/*
 * TDOA㷨ʵ
 * GetPos
 *		ʵֱߺ˫󽻵
 * param
 *		pRP    ------ վ·
 *      dist   ------ 
 *      i	   ------ i߶
 *
 * return
 *      Ľ⣬
 *
*/
typedef struct 
{
	double x;
	double y;
	double z;
}PositionStr;

int calc_card_position(ReceiveData stationFirst, ReceiveData stationSecond, double distanceDiff, PositionStr& result)
{
	double station_distance = sqrt(pow((stationFirst.x - stationSecond.x), 2) + pow((stationFirst.y - stationSecond.y),2));
    double diff_check = abs(abs(station_distance) - abs(distanceDiff));
	if(abs(distanceDiff) > station_distance)
	{
	    //debug_print_syslog(0, "calc_card_position, distanceDiff is longer than stationDistance, read_id_first: %d,read_id_second: %d, diff_check: %f,\
		//	first_time: %I64u, second_time: %I64u, station_distance: %f, distanceDiff: %f",
		//	stationFirst.reader_id, stationSecond.reader_id,
		//	diff_check, stationFirst.rec_time_stamp, stationSecond.rec_time_stamp, station_distance, distanceDiff);
		return -1;
	}

	if(diff_check < 4)
	{
	    //debug_print_syslog(0, "calc_card_position, read_id_first: %d,read_id_second: %d, diff_check: %f,\
		//	first_time: %I64u, second_time: %I64u, station_distance: %f, distanceDiff: %f",
		//	stationFirst.reader_id, stationSecond.reader_id,
		//	diff_check, stationFirst.rec_time_stamp, stationSecond.rec_time_stamp, station_distance, distanceDiff);
		return -1;
	}
	double m = station_distance + distanceDiff;
	
	double n = station_distance - distanceDiff;
	result.x = ((m * stationSecond.x) + (n * stationFirst.x))/(m + n);
	result.y = ((m * stationSecond.y) + (n * stationFirst.y))/(m + n);
	result.z = 0;
	return 0;
}

std::unique_ptr<POS> LocateAlgorithm::CalcCardPosition(std::shared_ptr<ReceiveDataMap> pRdm,std::shared_ptr<TDOAReaderPathMap> trpm)
{
    std::unique_ptr<POS> pos(new POS);

	double a = 0;
	double ref_dist = 0.0;   //վ֮·ľ
	
	const int Totals = 10;
	_coordinate res;
	int res_idx = 0;

	bool bFirst = true;
	int nNoReaderPathIdx = 0;
	int nFirstReader[Totals] = {-1};
	int nSecondReader[Totals] ={-1};

	pos->posx = INVALID_COORDINATE;
	pos->posy = INVALID_COORDINATE;
	pos->posz = INVALID_COORDINATE;
	pos->reason = ALGO_FAILED_CONDITION_1;

	//洢·վid
	ReceiveData tmp_reader[Totals];

	//洢͵һվ·ķվϢ
	ReceiveData tmp_dist_reader[Totals];
	int nDistReaders = 0;

	for(ReceiveDataMap::iterator it_tmp = pRdm->begin(); it_tmp != pRdm->end(); it_tmp++)
	{
	    //debug_print_syslog(0, "Calculate data, read_id_second: %d, rec_time_stamp: %I64u",
		//	it_tmp->second->reader_id, it_tmp->second->rec_time_stamp);
	}
	ReceiveDataMap::iterator first = pRdm->begin();
	ReceiveDataMap::iterator second = first;
	//ƫƵڶԪ
	std::advance(second,1);

	//ȡһʱ
	ReceiveData f1;
	f1.antenna_id = first->second->antenna_id;
	f1.reader_id = first->second->reader_id;
	f1.rec_time_stamp = first->second->rec_time_stamp;
	f1.x = first->second->x;
	f1.y = first->second->y;
	f1.z = first->second->z;

	//ӵڶʼ
	for(; second != pRdm->end(); ++second)
	{
		//ȡڶʱ
		ReceiveData f2;
		f2.antenna_id = second->second->antenna_id;
		f2.reader_id = second->second->reader_id;
		f2.rec_time_stamp = second->second->rec_time_stamp;
		f2.x = second->second->x;
		f2.y = second->second->y;
		f2.z = second->second->z;

		//ʱ쳣
		if(f1.rec_time_stamp == LLONG_MAX || f2.rec_time_stamp == LLONG_MAX){
			continue;
		}

		if(f1.reader_id == f2.reader_id){
			continue;
		}

		//ҵм򣬱ûд·ͼ
		TDOAReaderPathMap::iterator rdm_it = trpm->find(f1.reader_id);
		if(rdm_it == trpm->end()){
			continue;
		}

		ReaderPathMap::iterator rpm_it = trpm->find(f1.reader_id)->second->find(f2.reader_id);
		if(rpm_it == trpm->find(f1.reader_id)->second->end()){
			continue;
		}else{
			//͵һվڵͼ
			tmp_dist_reader[nDistReaders].reader_id = f2.reader_id;
			tmp_dist_reader[nDistReaders].x = f2.x;
			tmp_dist_reader[nDistReaders].y = f2.y;
			tmp_dist_reader[nDistReaders].z = f2.z;
			tmp_dist_reader[nDistReaders].rec_time_stamp = f2.rec_time_stamp;
			nDistReaders++;
		}

		//ݾжϼλȡʱʹ
		int nSign = 1;
		long long diffTime = f1.rec_time_stamp - f2.rec_time_stamp;

		//λ
		double distDiff = CFunctions::getDistance(diffTime,CFunctions::TDOA);

		PositionStr stationFirst;
		stationFirst.x = f1.x;
		stationFirst.y = f1.y;
		PositionStr stationSecond;
		stationSecond.x = f2.x;
		stationSecond.y = f2.y;
		PositionStr result;
		int rt_val = 0;
		rt_val = calc_card_position(f1, f2, distDiff, result);
		if(0 == rt_val)
		{
		    res.x = result.x;
		    res.y = result.y;
		    res.z = result.z;
		    res.reason = ALGO_LOC_SUCCESSED;
		    res_idx++;
			pos->posx = res.x;
        	pos->posy = res.y;
        	pos->posz = res.z;
        	pos->reason = res.reason;
        	return pos;
		}
		
	}
	return pos;
}

std::shared_ptr<SOLUTION> LocateAlgorithm::GetPos(std::shared_ptr<ReaderPath> pRP,double dist,int i)
{
	//ĸ
	int count = 0;

	//
	double x[2];
	double y[2];
	//double z[2];

	for (int t=0;t<2;t++)
	{
		x[t] = y[t] = INVALID_COORDINATE;
	}

	//˫ߵֱ
	double x1 = pRP->x[0];
	double y1 = pRP->y[0];
	double z1 = pRP->z[0];

	double x2 = pRP->x[1];
	double y2 = pRP->y[1];
	double z2 = pRP->z[1];

	if(pRP->px[i] - pRP->px[i+1] == 0){
		//xȣ˫Y
		x[0] = x[1] = pRP->px[i];
		y[0] = (y1 + y2 + dist)/2.0;
		y[1] = (y1 + y2 - dist)/2.0;
		count = 2;
	}
	else{
		//˫ߺֱཻ
		//ֱ߳
		double k = (pRP->py[i+1] - pRP->py[i])/(pRP->px[i+1] - pRP->px[i]);
		double kb = pRP->py[i] - k*pRP->px[i];

		//ĳм
		double d1 = 2*(x2 - x1);//m
		double d2 = 2*(y2 - y1);//n
		double d3 = pow(y1,2) + pow(x1,2)- pow(dist,2) - pow(y2,2)  - pow(x2,2);//p
		//ax^2 + bx + c = 0
		double a = pow(d1 + d2*k,2) - 4*pow(dist,2)*(pow(k,2) + 1);
		double b = 2*((d3 + d2*kb)*(d1 + d2*k) - 4*pow(dist,2)*(k*(kb - y2) - x2));
		double c = pow(d3 + d2*kb,2) - 4*pow(dist,2)*(pow(x2,2) + pow(kb-y2,2));

		double delta = pow(b,2) - 4*a*c;
		if(delta > 0){
			count = 2;
		}
		else if(delta == 0){
			count = 1;
		}
		else{
			count = 0;
		}

		if(count == 0){
			return nullptr;
		}

		//
		x[0] = -(b + sqrt(delta))/(2*a);
		x[1] = (-b + sqrt(delta) )/(2*a);
		y[0] = k*x[0] + kb;
		y[1] = k*x[1] + kb;	
	}
	int nIdx = 0;
	int nValidCount = count;
	//
	double deviation = 0.0;
	//жǷ߶ηΧ
	if(count > 0){
		for(int t = 0; t < count ;t++){
			//վ֮i߶ε˵
			if(x[t] < min(pRP->px[i],pRP->px[i+1]) - deviation||
			   x[t] > max(pRP->px[i],pRP->px[i+1]) + deviation||
			   y[t] < min(pRP->py[i],pRP->py[i+1]) - deviation||
			   y[t] > max(pRP->py[i],pRP->py[i+1]) + deviation
				)
			{
				x[t] = INVALID_COORDINATE;
				y[t] = INVALID_COORDINATE;
				nValidCount--;
				nIdx = t;
			}
		}
	}
	
	std::shared_ptr<SOLUTION> s = std::make_shared<SOLUTION>();

	s->nCount = nValidCount;

	nIdx = -1;
	switch(nValidCount){
	case 1:
		for(int i = 0;i<2;i++){
			if(x[i] != INVALID_COORDINATE && y[i] != INVALID_COORDINATE){
				nIdx = i;
			}
		}
		s->x[0] = x[nIdx];
		s->y[0] = y[nIdx];
		break;
	case 2:
		s->x[0] = x[0];
		s->x[1] = x[1];
		s->y[0] = y[0];
		s->y[1] = y[1];
		break;
	}

	return s;
}

/*
 * жڵͼ
 *
 * param
 *		pos   ------		λĽ
 *		trpm  ------		ͼ
 *
 * return
 *		falseڵͼϣtrueڵͼ
 *
*/
bool LocateAlgorithm::IsOnMap(std::shared_ptr<POS>& pos,std::shared_ptr<TDOAReaderPathMap> trpm)
{
	//ͼжҲ˷վʼĵͼͷfalse
	//if(trpm->find(pos->nFirstReader) == trpm->end()){
	//	return false;
	//}

	////ͼҲվĵͼͷfalse
	//if(trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader) == trpm->find(pos->nFirstReader)->second->end())
	//{
	//	return false;
	//}

	////վ
	//double x[2] = {0};
	//double y[2] = {0};

	//for(int i=0;i<2;i++){
	//	x[i] = trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->x[i];
	//	y[i] = trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->y[i];
	//}

	//if(x[0] == x[1]){
	//	//1cm
	//	if(abs(pos->posx - x[0]) > 1E-2){
	//		return false;
	//	}
	//}else{
	//	double k = (y[1] - y[0])/(x[1] - x[0]);
	//	double b = y[1] - k*x[1];

	//	double calc_y = k*pos->posx + b;

	//	if(abs(calc_y - pos->posy) > 1E-2){
	//		return false;
	//	}
	//}

	bool bExist = false;
	for (TDOAReaderPathMap::iterator first = trpm->begin();first!=trpm->end();++first)
	{
		for (ReaderPathMap::iterator second = first->second->begin();second != first->second->end();++second)
		{
			_point p,start_p,end_p;

			p.x = pos->posx;
			p.y = pos->posy;

			start_p.x = second->second->px[0];
			start_p.y = second->second->py[0];

			end_p.x = second->second->px[1];
			end_p.y = second->second->py[1];

			bExist = LocateAlgorithm::IsInLine(p,start_p,end_p);
			if (bExist)
			{
				pos->nFirstReader = first->first;
				pos->nSecondReader = second->first;
				return bExist;
			}
			////վ
			//double x[2] = {0};
			//double y[2] = {0};
			//for(int i=0;i<2;i++){
			//	x[i] = second->second->x[i];
			//	y[i] = second->second->y[i];
			//}
			//if(abs(x[0] - x[1]) < 1E-4 && abs(pos->posx - x[0]) < 1E-4){
			//	//1cm
			//	if ((pos->posy > y[0] && pos->posy < y[1])||(pos->posy > y[1] && pos->posy < y[0]))
			//	{
			//		bExist = true;
			//		return bExist;
			//	}
			//}else{
			//	double k = (y[1] - y[0])/(x[1] - x[0]);
			//	double b = y[1] - k*x[1];

			//	double calc_y = k*pos->posx + b;

			//	if(abs(calc_y - pos->posy) < 1){
			//		bExist = true;
			//		return bExist;
			//	}
			//}
		}
	}
	
	return bExist;
}

bool LocateAlgorithm::IsInTriangle(std::vector<_point> vtp,_point p)
{
	double sabc = 0,sadb = 0,sbdc = 0,sadc = 0;
	sabc = GetTriangleArea(vtp[0],vtp[1],vtp[2]);
	sadb = GetTriangleArea(vtp[0],p,vtp[1]);
	sbdc = GetTriangleArea(vtp[1],p,vtp[2]);
	sadc = GetTriangleArea(vtp[0],p,vtp[2]);

	double sum = 0.0;
	sum = sadb + sbdc + sadc;
	if ((sabc - sum) > -1E-5 && (sabc - sum) < 1E-5)
	{
		return true;
	} 
	else
	{
		return false;
	}
}

double LocateAlgorithm::GetTriangleArea(_point p0,_point p1,_point p2)
{
	_point ab,bc;

	ab.x = p1.x - p0.x;
	ab.y = p1.y - p0.y;

	bc.x = p2.x - p1.x;
	bc.y = p2.y - p1.y;

	return abs(ab.x*bc.y - ab.y*bc.x)/2.0;
}

/*
 * PǷstart_pend_p߶
 *
 * param
 *		p			ʶ
 *		start_p		߶ζ˵
 *		end_p		߶յ
 *
 * return
 *		߶Ϸtrue򷵻false
 *
*/
bool LocateAlgorithm::IsInLine(_point p,_point start_p,_point end_p)
{
	double d1 = 0, d2 = 0, d3 = 0;

	d1 = sqrt(pow(p.x - start_p.x,2) + pow(p.y - start_p.y,2));
	d2 = sqrt(pow(p.x - end_p.x,2) + pow(p.y - end_p.y,2));
	d3 = sqrt(pow(start_p.x - end_p.x,2) + pow(start_p.y - end_p.y,2));

	double d4 = 0;
	d4 = abs(d3 - (d1 + d2));
	if (d4 < OFFSET_THRE_IN_LINE)
	{
		//ӵǷstart_pend_pΪľ
		if (abs(start_p.x - end_p.x) < ZERO_PRECISION)
		{
			if (p.y > min(start_p.y,end_p.y) && p.y < max(start_p.y,end_p.y))
			{
				return true;
			}else{
				return false;
			}
		}else if(abs(start_p.y - end_p.y) < ZERO_PRECISION){
			if(p.x > min(start_p.x,end_p.x) && p.x < max(start_p.x,end_p.x)) {
				return true;
			}else{
				return false;
			}
		}else{
			if(p.x > min(start_p.x,end_p.x) && p.x < max(start_p.x,end_p.x) 
				&& p.y > min(start_p.y,end_p.y) && p.y < max(start_p.y,end_p.y))
			{
				return true;
			}else{
				return false;
			}
		}
	}
	return false;
}

bool LocateAlgorithm::PointIsInRect(_point p,_point tp,_point lp,_point bp,_point rp)
{
	//ı4  
	int nCount = 4;  
	_point RectPoints[4] = { tp, lp, bp, rp };  
	int nCross = 0;  
	for (int i = 0; i < nCount; i++)   
	{   
		//ȡڵ  
		_point pStart = RectPoints[i];   
		_point pEnd = RectPoints[(i + 1) % nCount];  

		//ڵƽxģ϶ཻ  
		if ( pStart.y == pEnd.y )   
			continue;  

		//pStart,pEndӳϣpCur϶pStart.pEndཻ  
		if ( p.y < min(pStart.y, pEnd.y) || p.y > max( pStart.y, pEnd.y ) )   
			continue;  

		//ǰxƽpStart,pEndֱߵĽx  
		double x = (double)(p.y - pStart.y) * (double)(pEnd.x - pStart.x) / (double)(pEnd.y - pStart.y) + pStart.x;  

		//xڵǰ꣬н  
		if ( x > p.x )   
			nCross++;   
	}  

	// ߽Ϊżڶ֮   
	return (nCross % 2 == 1);   
}

int LocateAlgorithm::CalcTdoaPosition(std::shared_ptr<ReceiveDataMap> pRdm,std::shared_ptr<TDOAReaderPathMap> trpm,std::vector<std::shared_ptr<POS>>& udm_pos)
{
	//ⲿӦ÷ŵװݺ
	//һѡ׼վ£
	//1.׼վѡ񣺵ǰվͺһվеͼѡΪ׼վ
	//2.ǰվͺзվ޵ͼǰվǻ׼վ
	//3.ظ1,2
	for (ReceiveDataMap::iterator first = pRdm->begin();first != pRdm->end();)
	{
		ReceiveDataMap::iterator second = first;
		//secondƫƵڶԪ
		std::advance(second,1);

		//ҵм򣬱ûд·ͼ
		TDOAReaderPathMap::iterator rdm_it = trpm->find(first->second->reader_id);
		if(rdm_it == trpm->end()){
			//ʾͼвڵһվ·ɾ˷վѭ
			pRdm->erase(first);
			first = pRdm->begin();
			continue;
		}

		//ͳfirstվͺվĵͼ
		int nCount = 0;		
		for (;second!= pRdm->end();++second)
		{
			//ȷϵһ͵ڶվ֮Ƿеͼ
			ReaderPathMap::iterator rpm_it = trpm->find(first->second->reader_id)->second->find(second->second->reader_id);
			if(rpm_it == trpm->find(first->second->reader_id)->second->end()){
				continue;
			}else{
				nCount++;
				break;
			}
		}

		//firstվͺվ޵ͼɾfirstվõ
		if (nCount == 0)
		{
			pRdm->erase(first);
			first = pRdm->begin();
		}else{
			first = second;
			break;
		}	
	}

	//λ2
	if (pRdm->size() < 2)
	{
		return ALGO_CALC_SOLUTION;
	}

	//һɸѡ
	//ǰվ꣬н⣬ֱӷأ޽⣬ڶɸѡ
	bool bNoSolution = true;
	//std::unique_ptr<POS> first_pos = LocateAlgorithm::Pos(pRdm,trpm);
	std::shared_ptr<POS> first_pos = LocateAlgorithm::Pos(pRdm,trpm);
	if (first_pos->posx != INVALID_COORDINATE && first_pos->posy != INVALID_COORDINATE)
	{
		std::shared_ptr<POS> sp = std::make_shared<POS>();
		*sp = *first_pos;
		udm_pos.push_back(sp);
		bNoSolution = false;
		return 0;
	}

	//޽Сڵ2򷵻ѡʧ
	//Ҫɸѡݣ޷λ
	if (bNoSolution && pRdm->size() <= 2)
	{
		return ALGO_CALC_NO_SOLUTION_WITH_TWO_DATA;
	}

	//ʼִеڶɸѡ
	ReceiveDataMap::iterator first = pRdm->begin();
	ReceiveDataMap::iterator second = first;
	if (bNoSolution)
	{
		//ΪfirstͺվѾͨϲж޽
		//3ƫƣһbug
		//103,104,301,102,105,106
		//ڵһʱ103104103102Ľжϸ޽
		//˴ƫ3ᵼ301
		//ԸΪ¶Ժн
		//ƫƵڶԪ
		std::advance(second,1);	
	} 

	//ƫƺԪǷ
	if (second == pRdm->end())
	{
		//ƫƺҲԪأش
		return ALGO_CALC_ONE_DATA;
	}

	//ȡһԪе
	ReceiveData f1;
	f1.antenna_id = first->second->antenna_id;
	f1.reader_id = first->second->reader_id;
	f1.rec_time_stamp = first->second->rec_time_stamp;
	f1.x = first->second->x;
	f1.y = first->second->y;
	f1.z = first->second->z;

	for(;second != pRdm->end();++second){
		//ȡڶеԪ
		ReceiveData f2;
		f2.antenna_id = second->second->antenna_id;
		f2.reader_id = second->second->reader_id;
		f2.rec_time_stamp = second->second->rec_time_stamp;
		f2.x = second->second->x;
		f2.y = second->second->y;
		f2.z = second->second->z;

		bool bExistPath = false;
		//һڣһԪ
		TDOAReaderPathMap::iterator rdm_it = trpm->find(f1.reader_id);
		if(rdm_it == trpm->end()){
			continue;
		}
		//ҵм򣬱ûд·ͼ
		ReaderPathMap::iterator rpm_it = trpm->find(f1.reader_id)->second->find(f2.reader_id);
		if(rpm_it != trpm->find(f1.reader_id)->second->end()){
			bExistPath = true;
		}

		//ݾжϼλȡʱʹ
		int nSign = 1;
		long long diffTime = f1.rec_time_stamp - f2.rec_time_stamp;

		//λ
		double dist = CFunctions::getDistance(diffTime,CFunctions::TDOA);

		double readers_dist = sqrt(pow(f1.x - f2.x,2) + pow(f1.y - f2.y,2));

		if(fabs(dist) - readers_dist > 0){
			continue;
		}

		//Ϣ
		std::shared_ptr<POS> pos = std::make_shared<POS>();

		if (bExistPath)
		{
			//ڵͼ
			std::shared_ptr<ReaderPath> pRP = trpm->find(f1.reader_id)->second->find(f2.reader_id)->second;
			//վ֮߶θ
			int seg_num = pRP->nRealCalcPoints - 1;

			if(seg_num == 0 || seg_num > 100){
				continue;
			}

			//Ϊ˫վ֮i߶λߵj߶ηֱ
			//߷վ֮һֱߣ
			double xcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
			double ycross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
			double zcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
			int nIdx = 0;

			for(int i = 0;i < seg_num;i++){
				//λ꣬˫ߺ߶ཻĽ
				std::shared_ptr<SOLUTION> r = LocateAlgorithm::GetPos(pRP,dist,i);
				//޽Ч
				if(r == nullptr || r->nCount == 0){
					continue;
				}
				int nPosCounts = 0;
				for (int i=0;i<r->nCount;i++)
				{
					xcross[nIdx] = r->x[i];
					ycross[nIdx] = r->y[i];
					nIdx++;
				}
				switch (nIdx)
				{
				case 1:
					pos->posx = xcross[0];
					pos->posy = ycross[0];
					pos->posz = zcross[0];

					udm_pos.push_back(pos);
					break;
				case 2:
					//ɸѡ⣺ѡһ
					//⵽֮ľ
					double deltad[2] = {0};
					for(int j = 0; j < 2;j ++){
						double d[2] = {0};
						double dx1 = xcross[j] - pRP->x[0];
						double dy1 = ycross[j] - pRP->y[0];
						d[0] = sqrt(pow(dx1,2) + pow(dy1,2));

						double dx2 = xcross[j] - pRP->x[1];
						double dy2 = ycross[j] - pRP->y[1];
						d[1] = sqrt(pow(dx2,2) + pow(dy2,2));

						deltad[j] = d[0] - d[1];
					}

					int idx = 0;	

					//Ӧú֮ǰdistͬ
					if(dist > 0){
						for(int j = 0;j < 2;j++){
							if(deltad[j] > 0){
								idx = j;
								break;
							}
						}	
					}else{
						for(int j = 0;j < 2;j++){
							if(deltad[j] < 0){
								idx = j;
								break;
							}
						}	
					}

					pos->nFirstReader  = f1.reader_id;
					pos->nSecondReader = f2.reader_id;

					pos->posx = xcross[idx];
					pos->posy = ycross[idx];
					pos->posz = zcross[idx];

					udm_pos.push_back(pos);
					break;
				}
			}
		} 
		else
		{
			//ڵͼҪǷڵͼϣ
			//ݾжϼλȡʱʹ
			//޵ͼĽ귽£
			double offset_d = (dist + readers_dist)/2;
			double calc_x = 0.0, calc_y = 0.0;

			//if (f1.x - f2.x < 1E-5)
			if (fabs(f1.x - f2.x) < ZERO_PRECISION)
			{
				//y
				calc_x = f1.x;
				if (f1.y > f2.y)
				{
					calc_y = f1.y - offset_d;
				} 
				else
				{
					calc_y = f1.y + offset_d;
				}
				
			}//else if (f1.y - f2.y < 1E-5)
			else if (fabs(f1.y - f2.y) < ZERO_PRECISION)
			{
				//x
				if (f1.x < f2.x)
				{
					calc_x = f1.x + offset_d;
				} 
				else
				{
					calc_x = f1.x - offset_d;
				}
				calc_y = f1.y;
			} 
			else
			{
				//бʵĵط
				double arg = atan((f2.y - f1.y)/(f2.x - f1.x));
				if (f1.x < f2.x && f1.y < f2.y)
				{
					calc_x = f1.x + cos(arg)*offset_d;
					calc_y = f1.y + sin(arg)*offset_d;
				} 
				else
				{
					calc_x = f1.x - cos(arg)*offset_d;
					calc_y = f1.y - sin(arg)*offset_d;
				}
				
			}

			pos->posx = calc_x;
			pos->posy = calc_y;
			pos->nFirstReader  = f1.reader_id;
			pos->nSecondReader = f2.reader_id;

			//ڣ˽Ч,ڣ˽Ч
			if (IsOnMap(pos,trpm))
			{
				udm_pos.push_back(pos);
			}	
		}	
	}

	if (udm_pos.size() == 0)
	{
		return ALGO_CALC_SOLUTION;
	}

	return 0;
}

int LocateAlgorithm::round(double value)
{
	return (value > 0.0)?floor(value + 0.5):ceil(value - 0.5);
}

bool LocateAlgorithm::CheckPosInValid(POS* pos,ReceiveDataMap* pRdm,double dScale)
{
	if(dScale <= 0.0){
		return false;
	}

	if(pos->posx == INVALID_COORDINATE || pos->posy == INVALID_COORDINATE){
		return false;
	}
	//жϽЧ
	int nSize = 0;
	bool bRet = false;

	nSize = pRdm->size();
	double dist[2] = {0.0};

	if(nSize == 2){
		int i = 0;
		for(ReceiveDataMap::iterator it = pRdm->begin();it!=pRdm->end();++it,i++){
			dist[i] = sqrt(pow(pos->posx - it->second->x,2)+pow(pos->posy - it->second->y,2));
			if(fabs(dist[i]) < NEAR_READER){
				//ڷΧڣжϴ˷վǷվ
				if(it->second->special){
					bRet = false;
				}else{
					bRet = true;
				}	
			}
		}	
	}

	return bRet;
}

std::shared_ptr<POS> LocateAlgorithm::MappingToPath( std::shared_ptr<POS> pos, std::shared_ptr<TDOAReaderPathMap> trpm )
{
	if(trpm->find(pos->nFirstReader) == trpm->end()){
		return nullptr;
	}
	if(trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader)==trpm->find(pos->nFirstReader)->second->end()){
		return nullptr;
	}

	std::shared_ptr<POS> p = std::make_shared<POS>();

	//õͼ
	std::shared_ptr<ReaderPath> pRP = trpm->find(pos->nFirstReader)->second->find(pos->nSecondReader)->second;

	// б
	// ֱ
	if(abs(pRP->x[0] - pRP->x[1]) < 1E-6)
	{
		p->posx = pRP->x[0];
		p->posy = pos->posy;
	}
	// ˮƽ
	else if(abs(pRP->y[0] - pRP->y[1]) < 1E-6)
	{
		p->posx = pos->posx;
		p->posy = pRP->y[0];
	}
	// б
	else
	{
		// ԭ y = kx + b, y' = -1/k x' + b'
		double k1= (pRP->y[1] - pRP->y[0]) / (pRP->x[1] - pRP->x[0]);
		double k2 = -1.0 / k1;

		double b1 = pRP->y[0] - k1 * pRP->x[0];
		double b2 = pos->posy - k2 * pos->posx;	

		p->posx = (b1 - b2)/(k2 - k1);
		p->posy = k2 * p->posx + b2;
	}

	return p;
}

void HeapSort(_coordinate** pCoordinateArray,int nLen)
{
	BuildMaxHeap(pCoordinateArray,nLen);
	
	for(int i = nLen - 1;i > 0;i--){
		SwapElement(pCoordinateArray[0],pCoordinateArray[i]);
		AdjustMaxHeap(pCoordinateArray,0,i-1);
	}
}

void BuildMaxHeap(_coordinate** pCoordinateArray,int nLen)
{
	for(int i = nLen/2 - 1;i > 0;i--){
		AdjustMaxHeap(pCoordinateArray,i,nLen-1);
	}
}

void AdjustMaxHeap(_coordinate** pCoordinateArray,int n,int nHeapSize)
{
	int l = (n+1)*2-1;
	int r = (n+1)*2;

	int max;

	if(l <= nHeapSize && pCoordinateArray[l]->tt > pCoordinateArray[n]->tt){
		max = l;
	}else{
		max = n;
	}

	if(r <= nHeapSize && pCoordinateArray[r]->tt > pCoordinateArray[max]->tt){
		max = r;
	}

	if(max != n){
		SwapElement(pCoordinateArray[n],pCoordinateArray[max]);
		AdjustMaxHeap(pCoordinateArray,max,nHeapSize);
	}
}

void SwapElement(_coordinate* a,_coordinate*b)
{
	_coordinate tmp;
	tmp = *a;
	*a = *b;
	*b = tmp;
}

void SelectSort(_coordinate** pCoordinateArray,int nLen)
{  
    for (int i=0; i<nLen; i++)  
    {  
        int k = i;  
        unsigned long long key = pCoordinateArray[i]->tt;  
        for (int j=i+1; j<nLen; j++)  
        {  
            if (pCoordinateArray[j]->tt < key) 
            {  
                k = j;  
                key = pCoordinateArray[j]->tt;  
            }  
        }  
        if (k!=i)  
            SwapElement(pCoordinateArray[i], pCoordinateArray[k]);  
    }  
}